## pcl-1.7 1.7.0

=== CMakeLists.txt ===
### ---[ PCL global CMake
cmake_minimum_required(VERSION 2.8 FATAL_ERROR)

set(CMAKE_CONFIGURATION_TYPES "Debug;Release" CACHE STRING "possible configurations" FORCE)

# In case the user does not setup CMAKE_BUILD_TYPE, assume it's RelWithDebInfo
if("${CMAKE_BUILD_TYPE}" STREQUAL "")
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type default to RelWithDebInfo, set to Release to improve performance" FORCE)
endif("${CMAKE_BUILD_TYPE}" STREQUAL "")

project(PCL)
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)

### ---[ Find universal dependencies
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/Modules/" ${CMAKE_MODULE_PATH})

# ---[ Release/Debug specific flags
if(CMAKE_BUILD_TYPE STREQUAL "Release" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
  add_definitions("-DBOOST_DISABLE_ASSERTS -DEIGEN_NO_DEBUG")
endif()
if(WIN32 AND NOT MINGW)
  if(NOT DEFINED CMAKE_DEBUG_POSTFIX)
    set(CMAKE_DEBUG_POSTFIX "_debug")
  endif()
  if(NOT DEFINED CMAKE_RELEASE_POSTFIX)
    set(CMAKE_RELEASE_POSTFIX "_release")
  endif()
endif()

# ---[ special maintainer mode
SET(CMAKE_CXX_FLAGS_MAINTAINER "-pedantic -Wno-variadic-macros -Weffc++ -Wno-long-long" CACHE STRING
    "Flags used by the C++ compiler during maintainer builds."
    FORCE)
SET(CMAKE_C_FLAGS_MAINTAINER "-pedantic -Wno-variadic-macros -Weffc++ -Wno-long-long" CACHE STRING
    "Flags used by the C compiler during maintainer builds."
    FORCE)
SET(CMAKE_EXE_LINKER_FLAGS_MAINTAINER
    "-Wl,--warn-unresolved-symbols,--warn-once" CACHE STRING
    "Flags used for linking binaries during maintainer builds."
    FORCE)
SET(CMAKE_SHARED_LINKER_FLAGS_MAINTAINER
    "-Wl,--warn-unresolved-symbols,--warn-once" CACHE STRING
    "Flags used by the shared libraries linker during maintainer builds."
    FORCE)
MARK_AS_ADVANCED(
    CMAKE_CXX_FLAGS_MAINTAINER
    CMAKE_C_FLAGS_MAINTAINER
    CMAKE_EXE_LINKER_FLAGS_MAINTAINER
    CMAKE_SHARED_LINKER_FLAGS_MAINTAINER )
# Update the documentation string of CMAKE_BUILD_TYPE for GUIs
SET(CMAKE_BUILD_TYPE "${CMAKE_BUILD_TYPE}" CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel Maintainer."
    FORCE)

# ---[ Android check
if (ANDROID)
  set (PCL_SHARED_LIBS OFF)
  message ("PCL shared libs on Android must be: ${PCL_SHARED_LIBS}")
endif()

include(${PCL_SOURCE_DIR}/cmake/pcl_verbosity.cmake)
include(${PCL_SOURCE_DIR}/cmake/pcl_targets.cmake)
include(${PCL_SOURCE_DIR}/cmake/pcl_options.cmake)

# Enable verbose timing display?
if(CMAKE_TIMING_VERBOSE AND UNIX)
  set_property(GLOBAL PROPERTY RULE_MESSAGES OFF)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CMAKE_SOURCE_DIR}/cmake/custom_output.sh")
endif(CMAKE_TIMING_VERBOSE AND UNIX)

# check for SSE flags
include(${PCL_SOURCE_DIR}/cmake/pcl_find_sse.cmake)
if (PCL_ENABLE_SSE)
  PCL_CHECK_FOR_SSE()
endif (PCL_ENABLE_SSE)

# ---[ Unix/Darwin/Windows specific flags
if(CMAKE_COMPILER_IS_GNUCXX)
  if("${CMAKE_CXX_FLAGS}" STREQUAL "")
    SET(CMAKE_CXX_FLAGS "-Wall -Wextra -Wno-unknown-pragmas -fno-strict-aliasing -Wno-format-extra-args -Wno-sign-compare -Wno-invalid-offsetof -Wno-conversion ${SSE_FLAGS}")

    # Enable -Wabi for GCC > 4.3, and -Wno-deprecated for GCC < 4.3
    # to disable a lot of warnings which are not fixable
    execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
    if (GCC_VERSION VERSION_GREATER 4.3)
      message(STATUS "-- GCC > 4.3 found, enabling -Wabi")
      SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wabi")
    else()
      message(STATUS "-- GCC < 4.3 found, enabling -Wno-deprecated")
      SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated")
    endif ()
  endif()

  if(NOT ANDROID)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")
  endif(NOT ANDROID)

  if(WIN32)
    if(PCL_SHARED_LIBS)
      SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--export-all-symbols -Wl,--enable-auto-import")
      if (MINGW)
        add_definitions("-DBOOST_THREAD_USE_LIB")
      endif()
    else(PCL_SHARED_LIBS)
      add_definitions("-DBOOST_LIB_DIAGNOSTIC -DBOOST_THREAD_USE_LIB")
    endif(PCL_SHARED_LIBS)
  endif()
endif()

if(MSVC)
  SET(CMAKE_COMPILER_IS_MSVC 1)
  add_definitions ("-DBOOST_ALL_NO_LIB -D_SCL_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS -DNOMINMAX /bigobj")
  if("${CMAKE_CXX_FLAGS}" STREQUAL "")
    SET(CMAKE_CXX_FLAGS "/bigobj /EHsc /fp:precise /wd4800 /wd4521 /wd4251 /wd4275 /wd4305 /wd4355 ${SSE_FLAGS}")

    # Add extra code generation/link optimizations
    if(CMAKE_MSVC_CODE_LINK_OPTIMIZATION)
      SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /GL")
      SET(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /LTCG")
      SET(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /LTCG")
    endif(CMAKE_MSVC_CODE_LINK_OPTIMIZATION)
    # /MANIFEST:NO") # please, don't disable manifest generation, otherwise crash at start for vs2008

    if(MSVC90 OR MSVC10 AND NOT ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} LESS 2.8 AND NOT ${CMAKE_MINOR_VERSION}.${CMAKE_PATCH_VERSION} LESS 8.6)
      include(ProcessorCount)
      ProcessorCount(N)
      if(NOT N EQUAL 0)
        SET(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP${N} ")
        SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP${N} ")
      endif()
    endif()
  endif()
endif()

if (__COMPILER_PATHSCALE)
  SET(CMAKE_COMPILER_IS_PATHSCALE 1)
  if("${CMAKE_CXX_FLAGS}" STREQUAL "")
    SET(CMAKE_CXX_FLAGS "-Wno-uninitialized -zerouv -pthread -mp")
  endif()
endif()

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  SET(CMAKE_COMPILER_IS_CLANG 1)
  if("${CMAKE_C_FLAGS}" STREQUAL "")
    SET(CMAKE_C_FLAGS "-Qunused-arguments")
  endif()
  if("${CMAKE_CXX_FLAGS}" STREQUAL "")
    SET(CMAKE_CXX_FLAGS "-Qunused-arguments -Wno-invalid-offsetof ${SSE_FLAGS}") # Unfortunately older Clang versions do not have this: -Wno-unnamed-type-template-args
  endif()
  SET(CLANG_LIBRARIES "stdc++")
endif()

# ---[ Project folders
option(USE_PROJECT_FOLDERS "Use folders to organize PCL projects in an IDE." OFF)
mark_as_advanced(USE_PROJECT_FOLDERS)
if(USE_PROJECT_FOLDERS)
  set_property(GLOBAL PROPERTY USE_FOLDERS ON)
endif(USE_PROJECT_FOLDERS)

include(${PCL_SOURCE_DIR}/cmake/pcl_utils.cmake)
set(PCL_VERSION 1.7.0 CACHE STRING "PCL version")
DISSECT_VERSION()
GET_OS_INFO()
SET_INSTALL_DIRS()

if(WIN32)
  set(PCL_RESOURCES_DIR ${PCL_SOURCE_DIR}/resources)
  set(PCL_POINTCLOUDS_DIR ${PCL_RESOURCES_DIR}/pointclouds)
endif(WIN32)

set(PCL_OUTPUT_LIB_DIR ${PCL_BINARY_DIR}/${LIB_INSTALL_DIR})
set(PCL_OUTPUT_BIN_DIR ${PCL_BINARY_DIR}/${BIN_INSTALL_DIR})
make_directory(${PCL_OUTPUT_LIB_DIR})
make_directory(${PCL_OUTPUT_BIN_DIR})
if(WIN32)
  foreach(config ${CMAKE_CONFIGURATION_TYPES})
    string(TOUPPER ${config} CONFIG)
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${CONFIG} "${PCL_OUTPUT_LIB_DIR}")
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${CONFIG} "${PCL_OUTPUT_BIN_DIR}")
    # ---[ Windows requires DLLs (shared libraries) to be installed in the same directory as executables
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${CONFIG} "${PCL_OUTPUT_BIN_DIR}")
  endforeach(config)
else(WIN32)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${PCL_OUTPUT_LIB_DIR}")
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PCL_OUTPUT_BIN_DIR}")
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PCL_OUTPUT_LIB_DIR}")
endif(WIN32)

# Add an "uninstall" target
configure_file("${PCL_SOURCE_DIR}/cmake/uninstall_target.cmake.in"
               "${PCL_BINARY_DIR}/uninstall_target.cmake" IMMEDIATE @ONLY)
add_custom_target(uninstall "${CMAKE_COMMAND}" -P
                  "${PCL_BINARY_DIR}/uninstall_target.cmake")

###
# this is copy paste form http://www.itk.org/Wiki/CMake_RPATH_handling
# in order to always make a full statement RPATH
###
SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}" is_system_dir)
IF("${is_system_dir}" STREQUAL "-1")
SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")
ENDIF("${is_system_dir}" STREQUAL "-1")

### ---[ Find universal dependencies
# the gcc-4.2.1 coming with MacOS X is not compatible with the OpenMP pragmas we use, so disabling OpenMP for it
if((NOT APPLE) OR (NOT CMAKE_COMPILER_IS_GNUCXX) OR (GCC_VERSION VERSION_GREATER 4.2.1))
  find_package(OpenMP)
endif()
if(OPENMP_FOUND)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
  message (STATUS "Found OpenMP")
  if(MSVC90 OR MSVC10)
    if(MSVC90)
      set(OPENMP_DLL VCOMP90)
    elseif(MSVC10)
      set(OPENMP_DLL VCOMP100)
    endif(MSVC90)
    set(CMAKE_SHARED_LINKER_FLAGS_DEBUG "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} /DELAYLOAD:${OPENMP_DLL}D.dll")
    set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /DELAYLOAD:${OPENMP_DLL}.dll")
  endif(MSVC90 OR MSVC10)
else(OPENMP_FOUND)
  message (STATUS "Not found OpenMP")
endif()
# Boost (required)
include(${PCL_SOURCE_DIR}/cmake/pcl_find_boost.cmake)
# Eigen (required)
find_package(Eigen REQUIRED)
include_directories(SYSTEM ${EIGEN_INCLUDE_DIRS})
add_definitions(-DEIGEN_USE_NEW_STDVECTOR
                -DEIGEN_YES_I_KNOW_SPARSE_MODULE_IS_NOT_STABLE_YET)
# FLANN (required)
if(NOT PCL_SHARED_LIBS OR (WIN32 AND NOT MINGW))
  set(FLANN_USE_STATIC ON)
endif(NOT PCL_SHARED_LIBS OR (WIN32 AND NOT MINGW))
find_package(FLANN 1.7.0 REQUIRED)
include_directories(${FLANN_INCLUDE_DIRS})

# libusb-1.0
find_package(libusb-1.0)
if(LIBUSB_1_FOUND)
  include_directories(${LIBUSB_1_INCLUDE_DIR})
endif(LIBUSB_1_FOUND)

# OpenNI
find_package(OpenNI)
if (OPENNI_FOUND)
  set(HAVE_OPENNI ON)
  include_directories(SYSTEM ${OPENNI_INCLUDE_DIRS})
endif()

# Fotonic (FZ_API)
find_package(FZAPI)
if (FZAPI_FOUND)
  set(HAVE_FZAPI ON)
  include_directories(SYSTEM ${FZAPI_INCLUDE_DIR})
endif()

# LibPNG
find_package(PNG)
if (PNG_FOUND)
  set (HAVE_PNG ON)
  include_directories(${PNG_INCLUDE_DIR})
endif(PNG_FOUND)

# Qhull
if(NOT PCL_SHARED_LIBS OR WIN32)
  set(QHULL_USE_STATIC ON)
endif(NOT PCL_SHARED_LIBS OR WIN32)
find_package(Qhull)

# Find QT4
find_package(Qt4)
if (QT4_FOUND)
  include(${QT_USE_FILE})
endif (QT4_FOUND)
# Find VTK
find_package(VTK)
if(VTK_FOUND)
  if (PCL_SHARED_LIBS OR 
      (NOT (PCL_SHARED_LIBS) AND NOT (VTK_BUILD_SHARED_LIBS)))
    set(VTK_FOUND TRUE)
    find_package (QVTK)
    message(STATUS "VTK found (include: ${VTK_INCLUDE_DIRS}, lib: ${VTK_LIBRARY_DIRS})")
    link_directories(${VTK_LIBRARY_DIRS})
    set(HAVE_VTK ON)
  else ()
    set(VTK_FOUND OFF)
    set(HAVE_VTK OFF)
    message ("Warning: You are to build PCL in STATIC but VTK is SHARED!")
    message ("Warning: VTK disabled!")
  endif ()
endif(VTK_FOUND)
# Find MPI
if (WITH_MPI) # this script searches for MPI 10 sec under windows, annoying especially if you do this often
  find_package(MPI)
  if(MPI_CXX_FOUND)
    include_directories(SYSTEM ${MPI_INCLUDE_PATH})
  endif(MPI_CXX_FOUND)
endif()
#Find Doxygen and html help compiler if any
find_package(Doxygen)
if(DOXYGEN_FOUND)
  find_package(HTMLHelp)
endif(DOXYGEN_FOUND)
#Find PCAP
find_package(Pcap)

### ---[ Create the config.h file
set(pcl_config_h_in "${CMAKE_CURRENT_SOURCE_DIR}/pcl_config.h.in")
set(pcl_config_h "${CMAKE_CURRENT_BINARY_DIR}/include/pcl/pcl_config.h")
configure_file(${pcl_config_h_in} ${pcl_config_h})
PCL_ADD_INCLUDES(common "" ${pcl_config_h})
include_directories(${CMAKE_CURRENT_BINARY_DIR}/include)

### ---[ Set up for tests
enable_testing()

### ---[ Set up for examples
#include(${PCL_SOURCE_DIR}/cmake/pcl_examples.cmake)

### ---[ Add the libraries subdirectories
include(${PCL_SOURCE_DIR}/cmake/pcl_targets.cmake)

collect_subproject_directory_names(${PCL_SOURCE_DIR} "CMakeLists.txt" PCL_MODULES_NAMES PCL_MODULES_DIRS doc)
set(PCL_MODULES_NAMES_UNSORTED ${PCL_MODULES_NAMES})

=== apps/CMakeLists.txt ===
set(SUBSYS_NAME apps)
set(SUBSYS_DESC "Application examples/samples that show how PCL works")
set(SUBSYS_DEPS common geometry io filters sample_consensus segmentation visualization kdtree features surface octree registration keypoints tracking search recognition)

# Find VTK
if(NOT VTK_FOUND)
    set(DEFAULT FALSE)
    set(REASON "VTK was not found.")
else(NOT VTK_FOUND)
    set(DEFAULT TRUE)
    set(REASON)
    include (${VTK_USE_FILE})
endif(NOT VTK_FOUND)

# OpenNI found?
if(NOT OPENNI_FOUND)
    set(DEFAULT FALSE)
    set(REASON "OpenNI was not found.")
else(NOT OPENNI_FOUND)
    set(DEFAULT TRUE)
    set(REASON)
endif(NOT OPENNI_FOUND)

set(DEFAULT FALSE)
PCL_SUBSYS_OPTION(build ${SUBSYS_NAME} ${SUBSYS_DESC} ${DEFAULT} ${REASON})
PCL_SUBSYS_DEPEND(build ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS} OPT_DEPS openni vtk)

if(build)

  include_directories (${CMAKE_CURRENT_BINARY_DIR})
  include_directories (${CMAKE_CURRENT_SOURCE_DIR}/include)

  PCL_ADD_EXECUTABLE(pcl_test_search_speed ${SUBSYS_NAME} src/test_search.cpp)
  target_link_libraries(pcl_test_search_speed pcl_common pcl_io pcl_search pcl_kdtree pcl_visualization)

  PCL_ADD_EXECUTABLE(pcl_nn_classification_example ${SUBSYS_NAME} src/nn_classification_example.cpp)
  target_link_libraries(pcl_nn_classification_example pcl_common pcl_io pcl_features pcl_kdtree)

  PCL_ADD_EXECUTABLE(pcl_pyramid_surface_matching ${SUBSYS_NAME} src/pyramid_surface_matching.cpp)
  target_link_libraries(pcl_pyramid_surface_matching pcl_common pcl_io pcl_features pcl_registration pcl_filters)

  PCL_ADD_EXECUTABLE(pcl_statistical_multiscale_interest_region_extraction_example ${SUBSYS_NAME} src/statistical_multiscale_interest_region_extraction_example.cpp)
  target_link_libraries(pcl_statistical_multiscale_interest_region_extraction_example pcl_common pcl_io pcl_features pcl_filters)

  if(LIBUSB_1_FOUND)
    PCL_ADD_EXECUTABLE(pcl_dinast_grabber ${SUBSYS_NAME} src/dinast_grabber_example.cpp)
    target_link_libraries(pcl_dinast_grabber pcl_common pcl_visualization pcl_io)
  endif(LIBUSB_1_FOUND)

  if (VTK_FOUND)
    PCL_ADD_EXECUTABLE(pcl_ppf_object_recognition ${SUBSYS_NAME} src/ppf_object_recognition.cpp)
    target_link_libraries(pcl_ppf_object_recognition pcl_common pcl_io pcl_filters pcl_features pcl_registration pcl_visualization pcl_sample_consensus pcl_segmentation)

    PCL_ADD_EXECUTABLE(pcl_multiscale_feature_persistence_example ${SUBSYS_NAME} src/multiscale_feature_persistence_example.cpp)
    target_link_libraries(pcl_multiscale_feature_persistence_example pcl_common pcl_io pcl_filters pcl_features pcl_visualization)

    PCL_ADD_EXECUTABLE(pcl_surfel_smoothing_test ${SUBSYS_NAME} src/surfel_smoothing_test.cpp)
    target_link_libraries(pcl_surfel_smoothing_test pcl_common pcl_io pcl_surface pcl_filters pcl_features pcl_visualization)

    PCL_ADD_EXECUTABLE(pcl_feature_matching ${SUBSYS_NAME} src/feature_matching.cpp)
    target_link_libraries(pcl_feature_matching pcl_common pcl_io pcl_registration pcl_keypoints pcl_sample_consensus pcl_visualization pcl_search pcl_features pcl_kdtree pcl_surface pcl_segmentation)

    PCL_ADD_EXECUTABLE(pcl_convolve ${SUBSYS_NAME} src/convolve.cpp)
    target_link_libraries(pcl_convolve pcl_common pcl_io pcl_visualization)

    PCL_ADD_EXECUTABLE(pcl_pcd_organized_multi_plane_segmentation ${SUBSYS_NAME} src/pcd_organized_multi_plane_segmentation.cpp)
    target_link_libraries(pcl_pcd_organized_multi_plane_segmentation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_features)

    PCL_ADD_EXECUTABLE(pcl_pcd_select_object_plane ${SUBSYS_NAME} src/pcd_select_object_plane.cpp)
    target_link_libraries(pcl_pcd_select_object_plane pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_features pcl_surface)

#    PCL_ADD_EXECUTABLE(pcl_convolve ${SUBSYS_NAME} src/convolve.cpp)
#    target_link_libraries(pcl_convolve pcl_common pcl_io pcl_visualization)

    if (OPENNI_FOUND AND BUILD_OPENNI)

#      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_grab_frame ${SUBSYS_NAME} src/openni_grab_frame.cpp)
#      target_link_libraries(pcl_openni_grab_frame pcl_common pcl_io pcl_visualization)

#      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_grab_images ${SUBSYS_NAME} src/openni_grab_images.cpp)
#      target_link_libraries(pcl_openni_grab_images pcl_common pcl_io pcl_visualization)


      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_fast_mesh ${SUBSYS_NAME} src/openni_fast_mesh.cpp)
      target_link_libraries(pcl_openni_fast_mesh pcl_common pcl_io pcl_visualization pcl_surface)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_voxel_grid ${SUBSYS_NAME} src/openni_voxel_grid.cpp)
      target_link_libraries(pcl_openni_voxel_grid pcl_common pcl_io pcl_filters pcl_visualization)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_octree_compression ${SUBSYS_NAME} src/openni_octree_compression.cpp)
      target_link_libraries(pcl_openni_octree_compression pcl_common pcl_io pcl_filters pcl_visualization pcl_octree)

      if(HAVE_PNG)
        PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_organized_compression ${SUBSYS_NAME} src/openni_organized_compression.cpp)
        target_link_libraries(pcl_openni_organized_compression pcl_common pcl_io pcl_filters pcl_visualization pcl_octree)
      endif(HAVE_PNG)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_shift_to_depth_conversion ${SUBSYS_NAME} src/openni_shift_to_depth_conversion.cpp)
      target_link_libraries(pcl_openni_shift_to_depth_conversion pcl_common pcl_visualization)

      PCL_ADD_EXECUTABLE(pcl_openni_mobile_server ${SUBSYS_NAME} src/openni_mobile_server.cpp)
      target_link_libraries(pcl_openni_mobile_server pcl_common pcl_io pcl_filters pcl_visualization)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_planar_segmentation ${SUBSYS_NAME} src/openni_planar_segmentation.cpp)
      target_link_libraries(pcl_openni_planar_segmentation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_organized_multi_plane_segmentation ${SUBSYS_NAME} src/openni_organized_multi_plane_segmentation.cpp)
      target_link_libraries(pcl_openni_organized_multi_plane_segmentation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_features)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_ii_normal_estimation ${SUBSYS_NAME} src/openni_ii_normal_estimation.cpp)
      target_link_libraries(pcl_openni_ii_normal_estimation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_features pcl_surface)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_feature_persistence ${SUBSYS_NAME} src/openni_feature_persistence.cpp)
      target_link_libraries(pcl_openni_feature_persistence pcl_common pcl_io pcl_filters pcl_visualization pcl_features)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_mls_smoothing ${SUBSYS_NAME} src/openni_mls_smoothing.cpp)
      target_link_libraries(pcl_openni_mls_smoothing pcl_common pcl_io pcl_surface pcl_visualization)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_change_viewer ${SUBSYS_NAME} src/openni_change_viewer.cpp)
      target_link_libraries(pcl_openni_change_viewer pcl_common pcl_io pcl_kdtree pcl_octree pcl_visualization pcl_filters)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_uniform_sampling ${SUBSYS_NAME} src/openni_uniform_sampling.cpp)
      target_link_libraries(pcl_openni_uniform_sampling pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_features pcl_surface pcl_keypoints)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_boundary_estimation ${SUBSYS_NAME} src/openni_boundary_estimation.cpp)
      target_link_libraries(pcl_openni_boundary_estimation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_features pcl_surface)

      if (QT4_FOUND AND VTK_USE_QVTK)
        # OpenNI Passthrough application demo
        QT4_WRAP_UI(openni_passthrough_ui src/openni_passthrough.ui)
        QT4_WRAP_CPP(openni_passthrough_moc include/pcl/apps/openni_passthrough.h OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED -DBOOST_NO_TEMPLATE_PARTIAL_SPECIALIZATION)
        PCL_ADD_EXECUTABLE(pcl_openni_passthrough ${SUBSYS_NAME} ${openni_passthrough_ui} ${openni_passthrough_moc} src/openni_passthrough.cpp)
        target_link_libraries(pcl_openni_passthrough pcl_common pcl_io pcl_filters pcl_visualization QVTK ${QT_LIBRARIES})

        # OpenNI Organized Connected Component application demo
        QT4_WRAP_UI(organized_segmentation_demo_ui src/organized_segmentation_demo.ui)
        QT4_WRAP_CPP(organized_segmentation_demo_moc include/pcl/apps/organized_segmentation_demo.h OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED -DBOOST_NO_TEMPLATE_PARTIAL_SPECIALIZATION)
        PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_organized_segmentation_demo ${SUBSYS_NAME} ${organized_segmentation_demo_ui} ${organized_segmentation_demo_moc} src/organized_segmentation_demo.cpp)
        target_link_libraries(pcl_organized_segmentation_demo pcl_common pcl_io pcl_visualization pcl_segmentation pcl_features pcl_surface QVTK ${QT_LIBRARIES})

        # Manual registration demo
        QT4_WRAP_UI(manual_registration_ui src/manual_registration/manual_registration.ui)
        QT4_WRAP_CPP(manual_registration_moc include/pcl/apps/manual_registration.h OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED -DBOOST_NO_TEMPLATE_PARTIAL_SPECIALIZATION)
        PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_manual_registration ${SUBSYS_NAME} ${manual_registration_ui} ${manual_registration_moc} src/manual_registration/manual_registration.cpp)
        target_link_libraries(pcl_manual_registration pcl_common pcl_io pcl_visualization pcl_segmentation pcl_features pcl_surface QVTK ${QT_LIBRARIES})

        QT4_WRAP_UI(pcd_video_player_ui src/pcd_video_player/pcd_video_player.ui)
        QT4_WRAP_CPP(pcd_video_player_moc include/pcl/apps/pcd_video_player.h OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED -DBOOST_NO_TEMPLATE_PARTIAL_SPECIALIZATION)
        PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_pcd_video_player ${SUBSYS_NAME} ${pcd_video_player_ui} ${pcd_video_player_moc} src/pcd_video_player/pcd_video_player.cpp)
        target_link_libraries(pcl_pcd_video_player pcl_common pcl_io pcl_visualization pcl_segmentation pcl_features pcl_surface QVTK ${QT_LIBRARIES})

        # Database processing (integration) demo
#        QT4_WRAP_UI(db_proc_ui src/db_proc/db_proc.ui)
#        QT4_WRAP_CPP(db_proc_moc include/pcl/apps/db_proc.h OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED)
#        PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_db_proc ${SUBSYS_NAME} ${db_proc_ui} ${db_proc_moc} src/db_proc/db_proc.cpp)
#        target_link_libraries(pcl_db_proc pcl_common pcl_io pcl_visualization pcl_segmentation pcl_features pcl_surface QVTK ${QT_LIBRARIES})

      endif ()

      set(incs
        include/pcl/${SUBSYS_NAME}/render_views_tesselated_sphere.h
        include/pcl/${SUBSYS_NAME}/timer.h)
      set(srcs src/render_views_tesselated_sphere.cpp)

      if (QHULL_FOUND)
        PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_3d_convex_hull ${SUBSYS_NAME} src/openni_3d_convex_hull.cpp)
        target_link_libraries(pcl_openni_3d_convex_hull pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_features pcl_surface)

        PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_3d_concave_hull ${SUBSYS_NAME} src/openni_3d_concave_hull.cpp)
        target_link_libraries(pcl_openni_3d_concave_hull pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_features pcl_surface)

        PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_tracking ${SUBSYS_NAME} src/openni_tracking.cpp)
        target_link_libraries(pcl_openni_tracking pcl_common pcl_io pcl_surface pcl_visualization pcl_filters pcl_features pcl_segmentation pcl_tracking pcl_search)

        set(incs include/pcl/${SUBSYS_NAME}/dominant_plane_segmentation.h ${incs})

=== geometry/CMakeLists.txt ===
set(SUBSYS_NAME geometry)
set(SUBSYS_DESC "Point cloud geometry library")
set(SUBSYS_DEPS common)

set(build TRUE)
PCL_SUBSYS_OPTION(build ${SUBSYS_NAME} ${SUBSYS_DESC} ON)
PCL_SUBSYS_DEPEND(build ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS})

PCL_ADD_DOC(${SUBSYS_NAME})

if(build)

  set(incs
      include/pcl/${SUBSYS_NAME}/boost.h
      include/pcl/${SUBSYS_NAME}/eigen.h
      include/pcl/${SUBSYS_NAME}/line_iterator.h
      include/pcl/${SUBSYS_NAME}/mesh_base.h
      include/pcl/${SUBSYS_NAME}/mesh_circulators.h
      include/pcl/${SUBSYS_NAME}/mesh_conversion.h
      include/pcl/${SUBSYS_NAME}/mesh_elements.h
      include/pcl/${SUBSYS_NAME}/mesh_indices.h
      include/pcl/${SUBSYS_NAME}/mesh_io.h
      include/pcl/${SUBSYS_NAME}/mesh_traits.h
      include/pcl/${SUBSYS_NAME}/organized_index_iterator.h
      include/pcl/${SUBSYS_NAME}/planar_polygon.h
      include/pcl/${SUBSYS_NAME}/polygon_operations.h
      include/pcl/${SUBSYS_NAME}/polygon_mesh.h
      include/pcl/${SUBSYS_NAME}/triangle_mesh.h
      include/pcl/${SUBSYS_NAME}/quad_mesh.h
     )

  set(impl_incs
      include/pcl/${SUBSYS_NAME}/impl/polygon_operations.hpp
     )

#  set(srcs
#      src/geometry.cpp
#     )

#  set(LIB_NAME pcl_${SUBSYS_NAME})
  include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
#  PCL_ADD_LIBRARY(${LIB_NAME} ${SUBSYS_NAME} ${srcs} ${incs} ${impl_incs})
#  target_link_libraries(${LIB_NAME} pcl_common)
#  PCL_MAKE_PKGCONFIG(${LIB_NAME} ${SUBSYS_NAME} "${SUBSYS_DESC}" "${SUBSYS_DEPS}" "" "" "" "")

  # Install include files
  PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME} ${incs})
  PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME}/impl ${impl_incs})

endif(build)

=== io/CMakeLists.txt ===
set(SUBSYS_NAME io)
set(SUBSYS_DESC "Point cloud IO library")
set(SUBSYS_DEPS common octree)

set(build TRUE)
PCL_SUBSYS_OPTION(build ${SUBSYS_NAME} ${SUBSYS_DESC} ON)
if(WIN32)
    PCL_SUBSYS_DEPEND(build ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS} OPT_DEPS openni vtk)
else(WIN32)
    PCL_SUBSYS_DEPEND(build ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS} OPT_DEPS openni vtk libusb-1.0)
endif(WIN32)

PCL_ADD_DOC(${SUBSYS_NAME})

if(build)
    OPTION(BUILD_OPENNI "Build the OpenNI Grabber." ON)
    MARK_AS_ADVANCED(BUILD_OPENNI)
    if(NOT BUILD_OPENNI)
      # Set OPENNI_FOUND to false locally to avoid building anything OpenNI related
      # Remember that other modules (libraries) need to check explicitly for BUILD_OPENNI
      set(OPENNI_FOUND FALSE) 
    endif()
    if(OPENNI_FOUND)
        set(OPENNI_GRABBER_INCLUDES
            include/pcl/io/openni_grabber.h
            include/pcl/io/oni_grabber.h
            )
        set(OPENNI_INCLUDES
            include/pcl/io/openni_camera/openni_shift_to_depth_conversion.h
            include/pcl/io/openni_camera/openni.h
            include/pcl/io/openni_camera/openni_depth_image.h
            include/pcl/io/openni_camera/openni_device.h
            include/pcl/io/openni_camera/openni_device_kinect.h
            include/pcl/io/openni_camera/openni_device_primesense.h
            include/pcl/io/openni_camera/openni_device_xtion.h
            include/pcl/io/openni_camera/openni_device_oni.h
            include/pcl/io/openni_camera/openni_driver.h
            include/pcl/io/openni_camera/openni_exception.h
            include/pcl/io/openni_camera/openni_image.h
            include/pcl/io/openni_camera/openni_image_bayer_grbg.h
            include/pcl/io/openni_camera/openni_image_yuv_422.h
            include/pcl/io/openni_camera/openni_image_rgb24.h
            include/pcl/io/openni_camera/openni_ir_image.h
            )
        set(OPENNI_GRABBER_SOURCES src/openni_camera/openni_device.cpp
            src/openni_camera/openni_device_primesense.cpp
            src/openni_camera/openni_image_bayer_grbg.cpp
            src/openni_camera/openni_depth_image.cpp
            src/openni_camera/openni_ir_image.cpp
            src/openni_camera/openni_device_kinect.cpp
            src/openni_camera/openni_device_xtion.cpp
            src/openni_camera/openni_device_oni.cpp
            src/openni_camera/openni_driver.cpp
            src/openni_camera/openni_exception.cpp
            src/openni_camera/openni_image_yuv_422.cpp
            src/openni_camera/openni_image_rgb24.cpp
            src/openni_grabber.cpp
            src/oni_grabber.cpp
            )
    endif(OPENNI_FOUND)

    if(FZAPI_FOUND)
        set(FZAPI_GRABBER_INCLUDES
            include/pcl/io/fotonic_grabber.h
            )
#        set(FZAPI_INCLUDES
#            include/pcl/io/openni_camera/openni.h
#            )
        set(FZAPI_GRABBER_SOURCES 
            src/fotonic_grabber.cpp
            )
    endif(FZAPI_FOUND)
	
    if(LIBUSB_1_FOUND)
        set(DINAST_GRABBER_INCLUDES
            include/pcl/io/dinast_grabber.h
           )
        set(DINAST_GRABBER_SOURCES
            src/dinast_grabber.cpp
           )
    endif(LIBUSB_1_FOUND)

    if (VTK_FOUND AND NOT ANDROID)
        set(VTK_USE_FILE ${VTK_USE_FILE} CACHE INTERNAL "VTK_USE_FILE")
        include (${VTK_USE_FILE})
        set(VTK_IO_INCLUDES 
            include/pcl/${SUBSYS_NAME}/vtk_lib_io.h
            include/pcl/${SUBSYS_NAME}/png_io.h 
           )
        set(VTK_IO_INCLUDES_IMPL
            include/pcl/${SUBSYS_NAME}/impl/vtk_lib_io.hpp
           )
        set(VTK_IO_SOURCE 
            src/vtk_lib_io.cpp
            src/png_io.cpp
           )
        set(VTK_IO_TARGET_LINK_LIBRARIES vtkCommon vtkWidgets vtkIO vtkImaging vtkHybrid vtkGraphics vtkRendering vtkFiltering vtkVolumeRendering)
        # Indicates that we can rely on VTK to be present
        set(VTK_DEFINES -DPCL_BUILT_WITH_VTK)
    endif ()

    set(PLY_SOURCES src/ply/ply_parser.cpp)
    set(PLY_INCLUDES 
        include/pcl/${SUBSYS_NAME}/ply/byte_order.h
        include/pcl/${SUBSYS_NAME}/ply/io_operators.h
        include/pcl/${SUBSYS_NAME}/ply/ply.h
        include/pcl/${SUBSYS_NAME}/ply/ply_parser.h
       )
    PCL_ADD_LIBRARY(pcl_io_ply ${SUBSYS_NAME} ${PLY_SOURCES} ${PLY_INCLUDES})
    PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME}/ply ${PLY_INCLUDES})

    set(srcs 
        src/debayer.cpp
        src/pcd_grabber.cpp
        src/pcd_io.cpp
        src/vtk_io.cpp
        src/ply_io.cpp
        src/ascii_io.cpp
        src/compression.cpp
        src/lzf.cpp
        src/lzf_image_io.cpp
        src/obj_io.cpp
        src/image_grabber.cpp
        src/hdl_grabber.cpp
        src/robot_eye_grabber.cpp
        ${VTK_IO_SOURCE}
        ${OPENNI_GRABBER_SOURCES}
        ${DINAST_GRABBER_SOURCES}
        ${FZAPI_GRABBER_SOURCES}
        )
    if(PNG_FOUND)
      set(srcs
          ${srcs}
          src/libpng_wrapper.cpp
          )
    endif(PNG_FOUND)

	if(PCAP_FOUND)
	  set(PCAP_DEFINES -DHAVE_PCAP)
          include_directories(${PCAP_INCLUDE_DIRS})
	  add_definitions(${PCAP_DEFINES})
	endif(PCAP_FOUND)

    set(incs 
        include/pcl/${SUBSYS_NAME}/boost.h
        include/pcl/${SUBSYS_NAME}/eigen.h
        include/pcl/${SUBSYS_NAME}/debayer.h
        include/pcl/${SUBSYS_NAME}/file_io.h
        include/pcl/${SUBSYS_NAME}/lzf.h
        include/pcl/${SUBSYS_NAME}/lzf_image_io.h
        include/pcl/${SUBSYS_NAME}/io.h
        include/pcl/${SUBSYS_NAME}/grabber.h
        include/pcl/${SUBSYS_NAME}/file_grabber.h
        include/pcl/${SUBSYS_NAME}/pcd_grabber.h
        include/pcl/${SUBSYS_NAME}/pcd_io.h
        include/pcl/${SUBSYS_NAME}/vtk_io.h
        include/pcl/${SUBSYS_NAME}/ply_io.h
        include/pcl/${SUBSYS_NAME}/tar.h
        include/pcl/${SUBSYS_NAME}/obj_io.h
        include/pcl/${SUBSYS_NAME}/ascii_io.h
        include/pcl/${SUBSYS_NAME}/image_grabber.h 
        include/pcl/${SUBSYS_NAME}/hdl_grabber.h
        include/pcl/${SUBSYS_NAME}/robot_eye_grabber.h
        ${VTK_IO_INCLUDES}
        ${OPENNI_GRABBER_INCLUDES}
        ${DINAST_GRABBER_INCLUDES}
        ${FZAPI_GRABBER_INCLUDES}
        )

    set(compression_incs
        include/pcl/compression/octree_pointcloud_compression.h
        include/pcl/compression/color_coding.h
        include/pcl/compression/compression_profiles.h
        include/pcl/compression/entropy_range_coder.h
        include/pcl/compression/point_coding.h
       )
    if(PNG_FOUND)
      set(compression_incs
          ${compression_incs}
          include/pcl/compression/organized_pointcloud_conversion.h
          include/pcl/compression/libpng_wrapper.h
          )
      if(OPENNI_FOUND)
        set(compression_incs
          ${compression_incs}
          include/pcl/compression/organized_pointcloud_compression.h
          )
      endif(OPENNI_FOUND)
    endif(PNG_FOUND)

    set(impl_incs 
        include/pcl/${SUBSYS_NAME}/impl/pcd_io.hpp
        include/pcl/${SUBSYS_NAME}/impl/lzf_image_io.hpp
        include/pcl/${SUBSYS_NAME}/impl/synchronized_queue.hpp
        include/pcl/compression/impl/entropy_range_coder.hpp
        include/pcl/compression/impl/octree_pointcloud_compression.hpp
        ${VTK_IO_INCLUDES_IMPL}
       )
    if(PNG_FOUND AND OPENNI_FOUND)
     set(impl_incs
         ${impl_incs}
         include/pcl/compression/impl/organized_pointcloud_compression.hpp
        )
    endif(PNG_FOUND AND OPENNI_FOUND)

    set(LIB_NAME pcl_${SUBSYS_NAME})

    include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include ${VTK_INCLUDE_DIRECTORIES})
    add_definitions(${VTK_DEFINES})
    PCL_ADD_LIBRARY(${LIB_NAME} ${SUBSYS_NAME} ${srcs} ${incs} ${compression_incs} ${impl_incs} ${OPENNI_INCLUDES})
    link_directories(${VTK_LINK_DIRECTORIES})
    target_link_libraries(${LIB_NAME} pcl_common pcl_io_ply ${VTK_IO_TARGET_LINK_LIBRARIES} )
    if(PNG_FOUND)
      target_link_libraries(${LIB_NAME} ${PNG_LIBRARY})
    endif(PNG_FOUND)

    if(LIBUSB_1_FOUND)
      target_link_libraries(${LIB_NAME} ${LIBUSB_1_LIBRARIES})
    endif(LIBUSB_1_FOUND)

    if(OPENNI_FOUND)
      target_link_libraries(${LIB_NAME} ${OPENNI_LIBRARIES})
    endif(OPENNI_FOUND)
	
    if(FZAPI_FOUND)
      target_link_libraries(${LIB_NAME} ${FZAPI_LIBS})
	  if(WIN32)
		target_link_libraries(${LIB_NAME} Version.lib)
  	  endif(WIN32)
    endif(FZAPI_FOUND)
    
    if (PCAP_FOUND)
      target_link_libraries(${LIB_NAME} ${PCAP_LIBRARIES})
    endif(PCAP_FOUND)

    set(EXT_DEPS eigen3)
    if(OPENNI_FOUND)
      list(APPEND EXT_DEPS openni-dev)
    endif(OPENNI_FOUND)
    PCL_MAKE_PKGCONFIG(${LIB_NAME} ${SUBSYS_NAME} "${SUBSYS_DESC}"
      "${SUBSYS_DEPS}" "${EXT_DEPS}" "" "" "")

    # Install include files
    PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME} ${incs})
    PCL_ADD_INCLUDES(${SUBSYS_NAME} compression ${compression_incs})
    PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME}/openni_camera ${OPENNI_INCLUDES})
    PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME}/impl ${impl_incs})
                
    add_subdirectory(tools)

endif(build)

=== recognition/CMakeLists.txt ===
set(SUBSYS_NAME recognition)
set(SUBSYS_DESC "Point cloud recognition library")
set(SUBSYS_DEPS common io search kdtree octree features filters registration sample_consensus)

set(build TRUE)
PCL_SUBSYS_OPTION(build ${SUBSYS_NAME} ${SUBSYS_DESC} ON)
PCL_SUBSYS_DEPEND(build ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS})

PCL_ADD_DOC(${SUBSYS_NAME})

if(build)
    set(LINEMOD_INCLUDES
        include/pcl/${SUBSYS_NAME}/linemod/line_rgbd.h
        )
    set(LINEMOD_IMPLS
        include/pcl/${SUBSYS_NAME}/impl/linemod/line_rgbd.hpp
        )

    set(incs 
        include/pcl/${SUBSYS_NAME}/boost.h
        include/pcl/${SUBSYS_NAME}/color_gradient_dot_modality.h
        include/pcl/${SUBSYS_NAME}/color_gradient_modality.h
		    include/pcl/${SUBSYS_NAME}/color_modality.h
		    include/pcl/${SUBSYS_NAME}/crh_alignment.h
        include/pcl/${SUBSYS_NAME}/linemod.h
        include/pcl/${SUBSYS_NAME}/dotmod.h
        include/pcl/${SUBSYS_NAME}/quantizable_modality.h
        include/pcl/${SUBSYS_NAME}/quantized_map.h
        include/pcl/${SUBSYS_NAME}/dot_modality.h
        include/pcl/${SUBSYS_NAME}/region_xy.h
        include/pcl/${SUBSYS_NAME}/mask_map.h
        include/pcl/${SUBSYS_NAME}/point_types.h
        include/pcl/${SUBSYS_NAME}/distance_map.h
        include/pcl/${SUBSYS_NAME}/dense_quantized_multi_mod_template.h
        include/pcl/${SUBSYS_NAME}/sparse_quantized_multi_mod_template.h
        include/pcl/${SUBSYS_NAME}/surface_normal_modality.h
        include/pcl/${SUBSYS_NAME}/linemod/line_rgbd.h
        include/pcl/${SUBSYS_NAME}/ransac_based/auxiliary.h
        include/pcl/${SUBSYS_NAME}/ransac_based/model_library.h
        include/pcl/${SUBSYS_NAME}/ransac_based/rigid_transform_space.h
        include/pcl/${SUBSYS_NAME}/ransac_based/obj_rec_ransac.h
        include/pcl/${SUBSYS_NAME}/ransac_based/orr_graph.h
        include/pcl/${SUBSYS_NAME}/ransac_based/orr_octree_zprojection.h
        include/pcl/${SUBSYS_NAME}/ransac_based/trimmed_icp.h
        include/pcl/${SUBSYS_NAME}/ransac_based/orr_octree.h
        include/pcl/${SUBSYS_NAME}/ransac_based/simple_octree.h
        include/pcl/${SUBSYS_NAME}/ransac_based/voxel_structure.h
        include/pcl/${SUBSYS_NAME}/ransac_based/bvh.h
	     	include/pcl/${SUBSYS_NAME}/implicit_shape_model.h
        )
        
    set(hv_incs
        include/pcl/${SUBSYS_NAME}/hv/occlusion_reasoning.h
        include/pcl/${SUBSYS_NAME}/hv/hypotheses_verification.h
        include/pcl/${SUBSYS_NAME}/hv/hv_papazov.h
        include/pcl/${SUBSYS_NAME}/hv/hv_go.h
        include/pcl/${SUBSYS_NAME}/hv/greedy_verification.h    
      )
      
    set(cg_incs
        include/pcl/${SUBSYS_NAME}/cg/correspondence_grouping.h
        include/pcl/${SUBSYS_NAME}/cg/hough_3d.h    
        include/pcl/${SUBSYS_NAME}/cg/geometric_consistency.h
        )
    

    set(impl_incs 
        include/pcl/${SUBSYS_NAME}/impl/linemod/line_rgbd.hpp
        include/pcl/${SUBSYS_NAME}/impl/ransac_based/simple_octree.hpp
        include/pcl/${SUBSYS_NAME}/impl/ransac_based/voxel_structure.hpp
		    include/pcl/${SUBSYS_NAME}/impl/implicit_shape_model.hpp
        )
        
    set(hv_impl_incs
        include/pcl/${SUBSYS_NAME}/impl/hv/occlusion_reasoning.hpp
        include/pcl/${SUBSYS_NAME}/impl/hv/hv_papazov.hpp        
        include/pcl/${SUBSYS_NAME}/impl/hv/greedy_verification.hpp
        include/pcl/${SUBSYS_NAME}/impl/hv/hv_go.hpp
    )
    
    set(cg_impl_incs
        include/pcl/${SUBSYS_NAME}/impl/cg/correspondence_grouping.hpp
        include/pcl/${SUBSYS_NAME}/impl/cg/hough_3d.hpp
        include/pcl/${SUBSYS_NAME}/impl/cg/geometric_consistency.hpp
        )

    set(srcs
        src/linemod.cpp
        src/quantizable_modality.cpp
        src/dotmod.cpp
        src/mask_map.cpp
        src/hv/occlusion_reasoning.cpp
        src/hv/hv_papazov.cpp
        src/hv/hv_go.cpp
        src/hv/greedy_verification.cpp
        src/cg/hough_3d.cpp
        src/cg/geometric_consistency.cpp
        src/ransac_based/obj_rec_ransac.cpp
        src/ransac_based/model_library.cpp
        src/ransac_based/orr_octree.cpp
        src/ransac_based/orr_octree_zprojection.cpp
		    src/implicit_shape_model.cpp
        )
        
    set(metslib_incs
        include/pcl/${SUBSYS_NAME}/3rdparty/metslib/abstract-search.hh
        include/pcl/${SUBSYS_NAME}/3rdparty/metslib/local-search.hh
        include/pcl/${SUBSYS_NAME}/3rdparty/metslib/mets.hh
        include/pcl/${SUBSYS_NAME}/3rdparty/metslib/metslib_config.hh
        include/pcl/${SUBSYS_NAME}/3rdparty/metslib/model.hh
        include/pcl/${SUBSYS_NAME}/3rdparty/metslib/observer.hh
        include/pcl/${SUBSYS_NAME}/3rdparty/metslib/simulated-annealing.hh
        include/pcl/${SUBSYS_NAME}/3rdparty/metslib/tabu-search.hh
        include/pcl/${SUBSYS_NAME}/3rdparty/metslib/termination-criteria.hh
    )

    set(LIB_NAME pcl_${SUBSYS_NAME})
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
    PCL_ADD_LIBRARY(${LIB_NAME} ${SUBSYS_NAME} ${srcs} ${incs} ${impl_incs} ${hv_incs} ${hv_impl_incs} ${cg_incs} ${cg_impl_incs} ${metslib_incs})
    target_link_libraries(${LIB_NAME} pcl_common pcl_kdtree pcl_octree pcl_search pcl_features pcl_registration pcl_sample_consensus pcl_filters pcl_io)
    PCL_MAKE_PKGCONFIG(${LIB_NAME} ${SUBSYS_NAME} "${SUBSYS_DESC}" "${SUBSYS_DEPS}" "" "" "" "")
    # Install include files
    PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME} ${incs})
    PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME}/hv ${hv_incs})
    PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME}/cg ${cg_incs})
    
    PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME}/impl ${impl_incs})
    PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME}/impl/hv ${hv_impl_incs})
    PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME}/impl/cg ${cg_impl_incs})
    PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME}/linemod ${LINEMOD_INCLUDES})
    PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME}/impl/linemod ${LINEMOD_IMPLS})

endif(build)

=== registration/CMakeLists.txt ===
set(SUBSYS_NAME registration)
set(SUBSYS_DESC "Point cloud registration library")
set(SUBSYS_DEPS common octree kdtree search sample_consensus features filters)

set(build TRUE)
PCL_SUBSYS_OPTION(build ${SUBSYS_NAME} ${SUBSYS_DESC} ON)
PCL_SUBSYS_DEPEND(build ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS})

PCL_ADD_DOC(${SUBSYS_NAME})

if(build)
    set(incs 
        include/pcl/${SUBSYS_NAME}/eigen.h
        include/pcl/${SUBSYS_NAME}/boost.h
        include/pcl/${SUBSYS_NAME}/boost_graph.h
        include/pcl/${SUBSYS_NAME}/convergence_criteria.h
        include/pcl/${SUBSYS_NAME}/default_convergence_criteria.h
        include/pcl/${SUBSYS_NAME}/correspondence_estimation.h
        include/pcl/${SUBSYS_NAME}/correspondence_estimation_normal_shooting.h
        include/pcl/${SUBSYS_NAME}/correspondence_estimation_backprojection.h
        include/pcl/${SUBSYS_NAME}/correspondence_estimation_organized_projection.h
        include/pcl/${SUBSYS_NAME}/correspondence_rejection.h
        include/pcl/${SUBSYS_NAME}/correspondence_rejection_distance.h
        include/pcl/${SUBSYS_NAME}/correspondence_rejection_median_distance.h
        include/pcl/${SUBSYS_NAME}/correspondence_rejection_surface_normal.h
        include/pcl/${SUBSYS_NAME}/correspondence_rejection_features.h
        include/pcl/${SUBSYS_NAME}/correspondence_rejection_one_to_one.h
        include/pcl/${SUBSYS_NAME}/correspondence_rejection_poly.h
        include/pcl/${SUBSYS_NAME}/correspondence_rejection_sample_consensus.h
        include/pcl/${SUBSYS_NAME}/correspondence_rejection_sample_consensus_2d.h
        include/pcl/${SUBSYS_NAME}/correspondence_rejection_trimmed.h
        include/pcl/${SUBSYS_NAME}/correspondence_rejection_var_trimmed.h
        include/pcl/${SUBSYS_NAME}/correspondence_rejection_organized_boundary.h
        include/pcl/${SUBSYS_NAME}/correspondence_sorting.h
        include/pcl/${SUBSYS_NAME}/correspondence_types.h
        include/pcl/${SUBSYS_NAME}/ia_ransac.h
        include/pcl/${SUBSYS_NAME}/icp.h
        include/pcl/${SUBSYS_NAME}/icp_nl.h
        include/pcl/${SUBSYS_NAME}/lum.h
        include/pcl/${SUBSYS_NAME}/elch.h
        include/pcl/${SUBSYS_NAME}/ndt.h
        include/pcl/${SUBSYS_NAME}/ndt_2d.h
        include/pcl/${SUBSYS_NAME}/ppf_registration.h

        include/pcl/${SUBSYS_NAME}/impl/pairwise_graph_registration.hpp

        include/pcl/${SUBSYS_NAME}/pyramid_feature_matching.h
        include/pcl/${SUBSYS_NAME}/registration.h
        include/pcl/${SUBSYS_NAME}/transforms.h
        include/pcl/${SUBSYS_NAME}/transformation_estimation.h
        include/pcl/${SUBSYS_NAME}/transformation_estimation_2D.h
        include/pcl/${SUBSYS_NAME}/transformation_estimation_svd.h
        include/pcl/${SUBSYS_NAME}/transformation_estimation_svd_scale.h
        include/pcl/${SUBSYS_NAME}/transformation_estimation_lm.h
        include/pcl/${SUBSYS_NAME}/transformation_estimation_point_to_plane.h
        include/pcl/${SUBSYS_NAME}/transformation_estimation_point_to_plane_weighted.h
        include/pcl/${SUBSYS_NAME}/transformation_estimation_point_to_plane_lls.h
        include/pcl/${SUBSYS_NAME}/transformation_estimation_point_to_plane_lls_weighted.h
        include/pcl/${SUBSYS_NAME}/transformation_validation.h
        include/pcl/${SUBSYS_NAME}/transformation_validation_euclidean.h
        include/pcl/${SUBSYS_NAME}/gicp.h
        include/pcl/${SUBSYS_NAME}/bfgs.h
        include/pcl/${SUBSYS_NAME}/warp_point_rigid.h
        include/pcl/${SUBSYS_NAME}/warp_point_rigid_6d.h
        include/pcl/${SUBSYS_NAME}/warp_point_rigid_3d.h
        include/pcl/${SUBSYS_NAME}/distances.h
        include/pcl/${SUBSYS_NAME}/exceptions.h
        include/pcl/${SUBSYS_NAME}/sample_consensus_prerejective.h
        )

    set(impl_incs 
        include/pcl/${SUBSYS_NAME}/impl/default_convergence_criteria.hpp
        include/pcl/${SUBSYS_NAME}/impl/correspondence_estimation.hpp
        include/pcl/${SUBSYS_NAME}/impl/correspondence_estimation_normal_shooting.hpp
        include/pcl/${SUBSYS_NAME}/impl/correspondence_estimation_backprojection.hpp
        include/pcl/${SUBSYS_NAME}/impl/correspondence_estimation_organized_projection.hpp
        include/pcl/${SUBSYS_NAME}/impl/correspondence_rejection.hpp
        include/pcl/${SUBSYS_NAME}/impl/correspondence_rejection_distance.hpp
        include/pcl/${SUBSYS_NAME}/impl/correspondence_rejection_median_distance.hpp
        include/pcl/${SUBSYS_NAME}/impl/correspondence_rejection_surface_normal.hpp
        include/pcl/${SUBSYS_NAME}/impl/correspondence_rejection_features.hpp
        include/pcl/${SUBSYS_NAME}/impl/correspondence_rejection_one_to_one.hpp
        include/pcl/${SUBSYS_NAME}/impl/correspondence_rejection_poly.hpp
        include/pcl/${SUBSYS_NAME}/impl/correspondence_rejection_sample_consensus.hpp
        include/pcl/${SUBSYS_NAME}/impl/correspondence_rejection_sample_consensus_2d.hpp
        include/pcl/${SUBSYS_NAME}/impl/correspondence_rejection_trimmed.hpp
        include/pcl/${SUBSYS_NAME}/impl/correspondence_rejection_var_trimmed.hpp
        include/pcl/${SUBSYS_NAME}/impl/correspondence_rejection_organized_boundary.hpp
        include/pcl/${SUBSYS_NAME}/impl/correspondence_types.hpp
        include/pcl/${SUBSYS_NAME}/impl/ia_ransac.hpp
        include/pcl/${SUBSYS_NAME}/impl/icp.hpp
        include/pcl/${SUBSYS_NAME}/impl/icp_nl.hpp
        include/pcl/${SUBSYS_NAME}/impl/elch.hpp
        include/pcl/${SUBSYS_NAME}/impl/lum.hpp
        include/pcl/${SUBSYS_NAME}/impl/ndt.hpp
        include/pcl/${SUBSYS_NAME}/impl/ndt_2d.hpp
        include/pcl/${SUBSYS_NAME}/impl/ppf_registration.hpp
        include/pcl/${SUBSYS_NAME}/impl/pyramid_feature_matching.hpp
        include/pcl/${SUBSYS_NAME}/impl/registration.hpp
        include/pcl/${SUBSYS_NAME}/impl/transformation_estimation_2D.hpp
        include/pcl/${SUBSYS_NAME}/impl/transformation_estimation_svd.hpp
        include/pcl/${SUBSYS_NAME}/impl/transformation_estimation_svd_scale.hpp
        include/pcl/${SUBSYS_NAME}/impl/transformation_estimation_lm.hpp
        include/pcl/${SUBSYS_NAME}/impl/transformation_estimation_point_to_plane_lls.hpp
        include/pcl/${SUBSYS_NAME}/impl/transformation_estimation_point_to_plane_lls_weighted.hpp
        include/pcl/${SUBSYS_NAME}/impl/transformation_estimation_point_to_plane_weighted.hpp
        include/pcl/${SUBSYS_NAME}/impl/transformation_validation_euclidean.hpp
        include/pcl/${SUBSYS_NAME}/impl/gicp.hpp
        include/pcl/${SUBSYS_NAME}/impl/sample_consensus_prerejective.hpp
        )

    set(srcs
        src/registration.cpp
        src/correspondence_estimation.cpp
        src/correspondence_estimation_normal_shooting.cpp
        src/correspondence_estimation_backprojection.cpp
        src/correspondence_estimation_organized_projection.cpp
        src/correspondence_rejection_distance.cpp
        src/correspondence_rejection_median_distance.cpp
        src/correspondence_rejection_surface_normal.cpp
        src/correspondence_rejection_features.cpp
        src/correspondence_rejection_one_to_one.cpp
        src/correspondence_rejection_poly.cpp
        src/correspondence_types.cpp
        src/correspondence_rejection_sample_consensus.cpp
        src/correspondence_rejection_sample_consensus_2d.cpp
        src/correspondence_rejection_trimmed.cpp
        src/correspondence_rejection_var_trimmed.cpp
        src/correspondence_rejection_organized_boundary.cpp
        src/ppf_registration.cpp
        src/pyramid_feature_matching.cpp
        #src/pairwise_graph_registration.cpp
        src/ia_ransac.cpp
        src/icp.cpp
        src/gicp.cpp
        src/icp_nl.cpp
        src/elch.cpp
        src/lum.cpp
        src/ndt.cpp
        src/ndt_2d.cpp
        src/transformation_estimation_2D.cpp
        src/transformation_estimation_svd.cpp
        src/transformation_estimation_svd_scale.cpp
        src/transformation_estimation_lm.cpp
        src/transformation_estimation_point_to_plane_weighted.cpp
        src/transformation_estimation_point_to_plane_lls.cpp
        src/transformation_estimation_point_to_plane_lls_weighted.cpp
        src/transformation_validation_euclidean.cpp
        src/sample_consensus_prerejective.cpp
        )

    set(LIB_NAME pcl_${SUBSYS_NAME})
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
    PCL_ADD_LIBRARY(${LIB_NAME} ${SUBSYS_NAME} ${srcs} ${incs} ${impl_incs})
    target_link_libraries(${LIB_NAME} pcl_kdtree pcl_search pcl_sample_consensus pcl_features pcl_filters)
    PCL_MAKE_PKGCONFIG(${LIB_NAME} ${SUBSYS_NAME} "${SUBSYS_DESC}"
      "${SUBSYS_DEPS}" "" "" "" "")
    # Install include files
    PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME} ${incs})
    PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME}/impl ${impl_incs})

endif(build)

=== surface/CMakeLists.txt ===
set(SUBSYS_NAME surface)
set(SUBSYS_DESC "Point cloud surface library")
set(SUBSYS_DEPS common search kdtree octree)

set(build TRUE)
PCL_SUBSYS_OPTION(build ${SUBSYS_NAME} ${SUBSYS_DESC} ON)
PCL_SUBSYS_DEPEND(build ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS} OPT_DEPS qhull)

PCL_ADD_DOC(${SUBSYS_NAME})

if(build)
    if(QHULL_FOUND)
        include_directories(${QHULL_INCLUDE_DIRS})
        set(HULL_INCLUDES
            include/pcl/${SUBSYS_NAME}/concave_hull.h
            include/pcl/${SUBSYS_NAME}/convex_hull.h
            include/pcl/${SUBSYS_NAME}/qhull.h
            )
        set(HULL_IMPLS
            include/pcl/${SUBSYS_NAME}/impl/concave_hull.hpp
            include/pcl/${SUBSYS_NAME}/impl/convex_hull.hpp
            )
        set(HULL_SOURCES
            src/concave_hull.cpp
            src/convex_hull.cpp
            )
    endif(QHULL_FOUND)
    
    if (VTK_FOUND AND NOT ANDROID)
        set(VTK_USE_FILE ${VTK_USE_FILE} CACHE INTERNAL "VTK_USE_FILE")
        include (${VTK_USE_FILE})
        
        set(VTK_SMOOTHING_INCLUDES 
            include/pcl/${SUBSYS_NAME}/vtk_smoothing/vtk.h
            include/pcl/${SUBSYS_NAME}/vtk_smoothing/vtk_utils.h
            include/pcl/${SUBSYS_NAME}/vtk_smoothing/vtk_mesh_subdivision.h
            include/pcl/${SUBSYS_NAME}/vtk_smoothing/vtk_mesh_quadric_decimation.h
            include/pcl/${SUBSYS_NAME}/vtk_smoothing/vtk_mesh_smoothing_laplacian.h
            include/pcl/${SUBSYS_NAME}/vtk_smoothing/vtk_mesh_smoothing_windowed_sinc.h)

        set(VTK_SMOOTHING_SOURCE 
            src/vtk_smoothing/vtk_utils.cpp
            src/vtk_smoothing/vtk_mesh_subdivision.cpp
            src/vtk_smoothing/vtk_mesh_quadric_decimation.cpp
            src/vtk_smoothing/vtk_mesh_smoothing_laplacian.cpp
            src/vtk_smoothing/vtk_mesh_smoothing_windowed_sinc.cpp)
        set(VTK_SMOOTHING_TARGET_LINK_LIBRARIES vtkCommon vtkWidgets vtkGraphics)
    endif()
    
    SET(BUILD_surface_on_nurbs 0 CACHE BOOL "Fitting NURBS to point-clouds using openNURBS" )
    IF(BUILD_surface_on_nurbs)
        include(src/3rdparty/opennurbs/openNURBS.cmake)
        include(src/on_nurbs/on_nurbs.cmake) 
    ENDIF(BUILD_surface_on_nurbs)

    set(POISSON_INCLUDES
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/allocator.h
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/binary_node.h
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/bspline_data.h
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/factor.h
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/function_data.h
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/geometry.h
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/hash.h
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/marching_cubes_poisson.h
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/mat.h
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/multi_grid_octree_data.h
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/octree_poisson.h
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/polynomial.h
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/ppolynomial.h
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/sparse_matrix.h
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/vector.h
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/bspline_data.hpp
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/function_data.hpp
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/geometry.hpp
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/mat.hpp
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/multi_grid_octree_data.hpp
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/octree_poisson.hpp
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/polynomial.hpp
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/ppolynomial.hpp
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/sparse_matrix.hpp
        include/pcl/${SUBSYS_NAME}/3rdparty/poisson4/vector.hpp
        )
    set(POISSON_SOURCES
        src/3rdparty/poisson4/factor.cpp
        src/3rdparty/poisson4/geometry.cpp
        src/3rdparty/poisson4/marching_cubes_poisson.cpp
        )
   
    set(srcs 
        src/processing.cpp 
        src/ear_clipping.cpp
        src/gp3.cpp
        src/grid_projection.cpp
        src/marching_cubes.cpp
        src/marching_cubes_hoppe.cpp
        src/marching_cubes_rbf.cpp
        src/bilateral_upsampling.cpp
        src/mls.cpp
        src/organized_fast_mesh.cpp
        src/simplification_remove_unused_vertices.cpp
        src/surfel_smoothing.cpp
        src/texture_mapping.cpp
        ${VTK_SMOOTHING_SOURCE}
        src/poisson.cpp
        ${HULL_SOURCES}
        ${POISSON_SOURCES}
        ${OPENNURBS_SOURCES}
        ${ON_NURBS_SOURCES}
        )

    set(incs 
        include/pcl/${SUBSYS_NAME}/boost.h
        include/pcl/${SUBSYS_NAME}/eigen.h
        include/pcl/${SUBSYS_NAME}/ear_clipping.h
        include/pcl/${SUBSYS_NAME}/gp3.h
        include/pcl/${SUBSYS_NAME}/grid_projection.h
        include/pcl/${SUBSYS_NAME}/marching_cubes.h
        include/pcl/${SUBSYS_NAME}/marching_cubes_hoppe.h
        include/pcl/${SUBSYS_NAME}/marching_cubes_rbf.h
        include/pcl/${SUBSYS_NAME}/bilateral_upsampling.h
        include/pcl/${SUBSYS_NAME}/mls.h
        include/pcl/${SUBSYS_NAME}/organized_fast_mesh.h
        include/pcl/${SUBSYS_NAME}/reconstruction.h
        include/pcl/${SUBSYS_NAME}/processing.h
        include/pcl/${SUBSYS_NAME}/simplification_remove_unused_vertices.h
        include/pcl/${SUBSYS_NAME}/surfel_smoothing.h        
        include/pcl/${SUBSYS_NAME}/texture_mapping.h
        include/pcl/${SUBSYS_NAME}/poisson.h
        ${HULL_INCLUDES}
      #  ${VTK_SMOOTHING_INCLUDES}
      #  ${POISSON_INCLUDES}
      #  ${OPENNURBS_INCLUDES}
      #  ${ON_NURBS_INCLUDES}
        )

    set(impl_incs 
        include/pcl/${SUBSYS_NAME}/impl/gp3.hpp
        include/pcl/${SUBSYS_NAME}/impl/grid_projection.hpp
        include/pcl/${SUBSYS_NAME}/impl/marching_cubes.hpp
        include/pcl/${SUBSYS_NAME}/impl/marching_cubes_hoppe.hpp
        include/pcl/${SUBSYS_NAME}/impl/marching_cubes_rbf.hpp
        include/pcl/${SUBSYS_NAME}/impl/bilateral_upsampling.hpp
        include/pcl/${SUBSYS_NAME}/impl/mls.hpp
        include/pcl/${SUBSYS_NAME}/impl/organized_fast_mesh.hpp
        include/pcl/${SUBSYS_NAME}/impl/reconstruction.hpp
        include/pcl/${SUBSYS_NAME}/impl/processing.hpp
        include/pcl/${SUBSYS_NAME}/impl/surfel_smoothing.hpp
        include/pcl/${SUBSYS_NAME}/impl/texture_mapping.hpp
        include/pcl/${SUBSYS_NAME}/impl/poisson.hpp
        ${HULL_IMPLS}
        )

    set(LIB_NAME pcl_${SUBSYS_NAME})
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include ${VTK_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR})
    link_directories(${VTK_LIBRARY_DIRS})
    PCL_ADD_LIBRARY(${LIB_NAME} ${SUBSYS_NAME} ${srcs} ${incs} ${impl_incs} ${VTK_SMOOTHING_INCLUDES} ${POISSON_INCLUDES} ${OPENNURBS_INCLUDES} ${ON_NURBS_INCLUDES})
    target_link_libraries(${LIB_NAME} pcl_common pcl_io pcl_search pcl_kdtree pcl_octree ${VTK_SMOOTHING_TARGET_LINK_LIBRARIES} ${ON_NURBS_LIBRARIES})
    if(QHULL_FOUND)
      target_link_libraries(${LIB_NAME} ${QHULL_LIBRARIES})
    endif(QHULL_FOUND)
    PCL_MAKE_PKGCONFIG(${LIB_NAME} ${SUBSYS_NAME} "${SUBSYS_DESC}" "${SUBSYS_DEPS}" "" "" "" "")

    # Install include files
    PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME} ${incs})
    PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME}/3rdparty/poisson4 ${POISSON_INCLUDES})
    PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME}/impl ${impl_incs})

    if(BUILD_surface_on_nurbs)
      add_definitions(-DUNICODE -D_UNICODE)
      PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME}/3rdparty/opennurbs ${OPENNURBS_INCLUDES})
      PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME}/on_nurbs ${ON_NURBS_INCLUDES})
    endif(BUILD_surface_on_nurbs)

    if (VTK_FOUND AND NOT ANDROID)
      PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME}/vtk_smoothing ${VTK_SMOOTHING_INCLUDES})
    endif (VTK_FOUND AND NOT ANDROID)
    if(WIN32)
      target_link_libraries(${LIB_NAME} Rpcrt4.lib)
    endif(WIN32)
endif(build)

=== test/CMakeLists.txt ===
set(SUBSYS_NAME global_tests)
set(SUBSYS_DESC "Point cloud library global unit tests")

if(BUILD_visualization)
  include (${VTK_USE_FILE})
  set(SUBSYS_DEPS common sample_consensus io kdtree features filters geometry keypoints search surface registration segmentation octree recognition people outofcore visualization)
  set(OPT_DEPS vtk)
else()
  set(SUBSYS_DEPS common sample_consensus io kdtree features filters geometry keypoints search surface registration segmentation octree recognition people outofcore)
endif()

set(DEFAULT OFF)
set(build TRUE)
PCL_SUBSYS_OPTION(build ${SUBSYS_NAME} ${SUBSYS_DESC} ${DEFAULT} ${REASON})
PCL_SUBSYS_DEPEND(build ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS} OPT_DEPS ${OPT_DEPS})

if(build)

    include_directories(${PCL_SOURCE_DIR}/test/gtest-1.6.0/include)
    include_directories(${PCL_SOURCE_DIR}/test/gtest-1.6.0/)
    add_library(pcl_gtest STATIC gtest-1.6.0/src/gtest-all.cc)

    enable_testing()
    include_directories(${PCL_INCLUDE_DIRS})

    add_subdirectory(common)
    add_subdirectory(features)
    add_subdirectory(filters)
    add_subdirectory(geometry)
    add_subdirectory(io)
    add_subdirectory(kdtree)
    add_subdirectory(octree)
    add_subdirectory(outofcore)
    add_subdirectory(registration)
    add_subdirectory(search)
    add_subdirectory(keypoints)
    add_subdirectory(surface)

	PCL_ADD_TEST(a_recognition_ism_test test_recognition_ism
                 FILES test_recognition_ism.cpp
                 LINK_WITH pcl_gtest pcl_io pcl_features
                 ARGUMENTS ${PCL_SOURCE_DIR}/test/ism_train.pcd ${PCL_SOURCE_DIR}/test/ism_test.pcd)

    PCL_ADD_TEST(search test_search
                 FILES test_search.cpp
                 LINK_WITH pcl_gtest pcl_search pcl_io pcl_kdtree
                 ARGUMENTS ${PCL_SOURCE_DIR}/test/table_scene_mug_stereo_textured.pcd)

    PCL_ADD_TEST(a_sample_consensus_test test_sample_consensus
                 FILES test_sample_consensus.cpp
                 LINK_WITH pcl_gtest pcl_io pcl_sample_consensus pcl_kdtree pcl_features
                 ARGUMENTS ${PCL_SOURCE_DIR}/test/sac_plane_test.pcd)
    
    PCL_ADD_TEST(a_transforms_test test_transforms
                 FILES test_transforms.cpp
                 LINK_WITH pcl_gtest pcl_io
                 ARGUMENTS ${PCL_SOURCE_DIR}/test/bun0.pcd)
    
    PCL_ADD_TEST(a_segmentation_test test_segmentation
                 FILES test_segmentation.cpp
                 LINK_WITH pcl_gtest pcl_io pcl_segmentation pcl_features pcl_kdtree pcl_search pcl_common
                 ARGUMENTS ${PCL_SOURCE_DIR}/test/bun0.pcd ${PCL_SOURCE_DIR}/test/car6.pcd ${PCL_SOURCE_DIR}/test/colored_cloud.pcd)
    
    PCL_ADD_TEST(test_non_linear test_non_linear
                 FILES test_non_linear.cpp
                 LINK_WITH pcl_gtest pcl_common pcl_io pcl_sample_consensus pcl_segmentation pcl_kdtree pcl_search 
                 ARGUMENTS ${PCL_SOURCE_DIR}/test/noisy_slice_displaced.pcd)

    PCL_ADD_TEST(a_recognition_cg_test test_recognition_cg
                 FILES test_recognition_cg.cpp
                 LINK_WITH pcl_gtest pcl_common pcl_io pcl_kdtree pcl_features pcl_recognition pcl_keypoints
                 ARGUMENTS ${PCL_SOURCE_DIR}/test/milk.pcd ${PCL_SOURCE_DIR}/test/milk_cartoon_all_small_clorox.pcd)   

    PCL_ADD_TEST(a_people_detection_test test_people_detection
                 FILES test_people_groundBasedPeopleDetectionApp.cpp
                 LINK_WITH pcl_gtest pcl_common pcl_io pcl_kdtree pcl_search pcl_features pcl_sample_consensus pcl_filters pcl_io pcl_segmentation pcl_people
                 ARGUMENTS ${PCL_SOURCE_DIR}/people/data/trainedLinearSVMForPeopleDetectionWithHOG.yaml ${PCL_SOURCE_DIR}/test/five_people.pcd )   

    if(BUILD_visualization AND (NOT UNIX OR (UNIX AND DEFINED ENV{DISPLAY})))
        PCL_ADD_TEST(a_visualization_test test_visualization
                 FILES test_visualization.cpp
                 LINK_WITH pcl_gtest pcl_io pcl_visualization pcl_features
                 ARGUMENTS ${PCL_SOURCE_DIR}/test/bunny.pcd)
    endif()

endif(build)

=== tools/CMakeLists.txt ===
set (SUBSYS_NAME tools)
set (SUBSYS_DESC "Useful PCL-based command line tools")
set (SUBSYS_DEPS common io filters sample_consensus segmentation search kdtree features surface octree registration recognition geometry keypoints)
set (DEFAULT ON)
set (REASON "")

PCL_SUBSYS_OPTION (build ${SUBSYS_NAME} ${SUBSYS_DESC} ${DEFAULT} ${REASON})
PCL_SUBSYS_DEPEND (build ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS})

if (build)

  PCL_ADD_EXECUTABLE(pcl_sac_segmentation_plane ${SUBSYS_NAME} sac_segmentation_plane.cpp)
  target_link_libraries(pcl_sac_segmentation_plane pcl_common pcl_io pcl_sample_consensus pcl_segmentation)

  PCL_ADD_EXECUTABLE (pcl_plane_projection ${SUBSYS_NAME} plane_projection.cpp)
  target_link_libraries (pcl_plane_projection pcl_common pcl_io pcl_sample_consensus)

  PCL_ADD_EXECUTABLE (pcl_normal_estimation ${SUBSYS_NAME} normal_estimation.cpp)
  target_link_libraries (pcl_normal_estimation pcl_common pcl_io pcl_features pcl_kdtree)

  PCL_ADD_EXECUTABLE (pcl_uniform_sampling ${SUBSYS_NAME} uniform_sampling.cpp)
  target_link_libraries (pcl_uniform_sampling pcl_common pcl_io pcl_filters pcl_keypoints pcl_kdtree)

  PCL_ADD_EXECUTABLE (pcl_boundary_estimation ${SUBSYS_NAME} boundary_estimation.cpp)
  target_link_libraries (pcl_boundary_estimation pcl_common pcl_io pcl_features pcl_kdtree)

  PCL_ADD_EXECUTABLE (pcl_cluster_extraction ${SUBSYS_NAME} cluster_extraction.cpp)
  target_link_libraries (pcl_cluster_extraction pcl_common pcl_io pcl_segmentation pcl_filters pcl_kdtree)

  PCL_ADD_EXECUTABLE (pcl_fpfh_estimation ${SUBSYS_NAME} fpfh_estimation.cpp)
  target_link_libraries (pcl_fpfh_estimation pcl_common pcl_io pcl_features pcl_kdtree)

  PCL_ADD_EXECUTABLE (pcl_pcd2ply ${SUBSYS_NAME} pcd2ply.cpp)
  target_link_libraries (pcl_pcd2ply pcl_common pcl_io)

  PCL_ADD_EXECUTABLE (pcl_ply2pcd ${SUBSYS_NAME} ply2pcd.cpp)
  target_link_libraries (pcl_ply2pcd pcl_common pcl_io)

  PCL_ADD_EXECUTABLE (pcl_xyz2pcd ${SUBSYS_NAME} xyz2pcd.cpp)
  target_link_libraries (pcl_xyz2pcd pcl_common pcl_io)

  PCL_ADD_EXECUTABLE (pcl_pclzf2pcd ${SUBSYS_NAME} pclzf2pcd.cpp)
  target_link_libraries (pcl_pclzf2pcd pcl_common pcl_io)

  PCL_ADD_EXECUTABLE (pcl_pcd2vtk ${SUBSYS_NAME} pcd2vtk.cpp)
  target_link_libraries (pcl_pcd2vtk pcl_common pcl_io)

  PCL_ADD_EXECUTABLE (pcl_vfh_estimation ${SUBSYS_NAME} vfh_estimation.cpp)
  target_link_libraries (pcl_vfh_estimation pcl_common pcl_io pcl_features pcl_kdtree)
  
  PCL_ADD_EXECUTABLE (pcl_spin_estimation ${SUBSYS_NAME} spin_estimation.cpp)
  target_link_libraries (pcl_spin_estimation pcl_common pcl_io pcl_features pcl_kdtree)

  PCL_ADD_EXECUTABLE (pcl_voxel_grid ${SUBSYS_NAME} voxel_grid.cpp)
  target_link_libraries (pcl_voxel_grid pcl_common pcl_io pcl_filters)
	
  PCL_ADD_EXECUTABLE (pcl_passthrough_filter ${SUBSYS_NAME} passthrough_filter.cpp)
  target_link_libraries (pcl_passthrough_filter pcl_common pcl_io pcl_filters)
	
  PCL_ADD_EXECUTABLE (pcl_radius_filter ${SUBSYS_NAME} radius_filter.cpp)
  target_link_libraries (pcl_radius_filter pcl_common pcl_io pcl_filters)

  PCL_ADD_EXECUTABLE (pcl_extract_feature ${SUBSYS_NAME} extract_feature.cpp)
  target_link_libraries (pcl_extract_feature pcl_common pcl_io pcl_features pcl_kdtree)
  
  PCL_ADD_EXECUTABLE (pcl_compute_cloud_error ${SUBSYS_NAME} compute_cloud_error.cpp)
  target_link_libraries (pcl_compute_cloud_error pcl_common pcl_io pcl_kdtree pcl_search)

  # NOTE: boost/uuid/uuid.hpp only exists for versions > 1.41
  if(Boost_MAJOR_VERSION GREATER 1 OR Boost_MINOR_VERSION GREATER 41)
    PCL_ADD_EXECUTABLE (pcl_add_gaussian_noise ${SUBSYS_NAME} add_gaussian_noise.cpp)
    target_link_libraries (pcl_add_gaussian_noise pcl_common pcl_io)
  endif()
  
  PCL_ADD_EXECUTABLE (pcl_outlier_removal ${SUBSYS_NAME} outlier_removal.cpp)
  target_link_libraries (pcl_outlier_removal pcl_common pcl_io pcl_filters)
  
  PCL_ADD_EXECUTABLE (pcl_mls_smoothing ${SUBSYS_NAME} mls_smoothing.cpp)
  target_link_libraries (pcl_mls_smoothing pcl_common pcl_io pcl_surface pcl_filters)
  
  PCL_ADD_EXECUTABLE (pcl_marching_cubes_reconstruction ${SUBSYS_NAME} marching_cubes_reconstruction.cpp)
  target_link_libraries (pcl_marching_cubes_reconstruction pcl_common pcl_io pcl_surface)

  PCL_ADD_EXECUTABLE (pcl_gp3_surface ${SUBSYS_NAME} gp3_surface.cpp)
  target_link_libraries (pcl_gp3_surface pcl_common pcl_io pcl_surface)
  
  PCL_ADD_EXECUTABLE(pcl_icp ${SUBSYS_NAME} icp.cpp)
  target_link_libraries(pcl_icp pcl_common pcl_io pcl_registration)

  PCL_ADD_EXECUTABLE(pcl_icp2d ${SUBSYS_NAME} icp2d.cpp)
  target_link_libraries(pcl_icp2d pcl_common pcl_io pcl_registration)

  PCL_ADD_EXECUTABLE(pcl_elch ${SUBSYS_NAME} elch.cpp)
  target_link_libraries(pcl_elch pcl_common pcl_io pcl_registration)

  PCL_ADD_EXECUTABLE(pcl_lum ${SUBSYS_NAME} lum.cpp)
  target_link_libraries(pcl_lum pcl_common pcl_io pcl_registration)

  PCL_ADD_EXECUTABLE(pcl_ndt2d ${SUBSYS_NAME} ndt2d.cpp)
  target_link_libraries(pcl_ndt2d pcl_common pcl_io pcl_registration)
    
  PCL_ADD_EXECUTABLE(pcl_ndt3d ${SUBSYS_NAME} ndt3d.cpp)
  target_link_libraries(pcl_ndt3d pcl_common pcl_io pcl_registration)

  PCL_ADD_EXECUTABLE(pcl_pcd_change_viewpoint ${SUBSYS_NAME} pcd_change_viewpoint.cpp)
  target_link_libraries(pcl_pcd_change_viewpoint pcl_common pcl_io)

  PCL_ADD_EXECUTABLE(pcl_concatenate_points_pcd ${SUBSYS_NAME} concatenate_points_pcd.cpp)
  target_link_libraries(pcl_concatenate_points_pcd pcl_common pcl_io)
  
  PCL_ADD_EXECUTABLE(pcl_poisson_reconstruction ${SUBSYS_NAME} poisson_reconstruction.cpp)
  target_link_libraries(pcl_poisson_reconstruction pcl_common pcl_io pcl_surface)

  PCL_ADD_EXECUTABLE(pcl_train_linemod_template ${SUBSYS_NAME} train_linemod_template.cpp)
  target_link_libraries(pcl_train_linemod_template pcl_common pcl_io pcl_segmentation pcl_recognition)

  PCL_ADD_EXECUTABLE(pcl_match_linemod_template ${SUBSYS_NAME} match_linemod_template.cpp)
  target_link_libraries(pcl_match_linemod_template pcl_common pcl_io pcl_recognition)

  PCL_ADD_EXECUTABLE(pcl_linemod_detection ${SUBSYS_NAME} linemod_detection.cpp)
  target_link_libraries(pcl_linemod_detection pcl_common pcl_io pcl_recognition)
  
  PCL_ADD_EXECUTABLE(pcl_fast_bilateral_filter ${SUBSYS_NAME} fast_bilateral_filter.cpp)
  target_link_libraries(pcl_fast_bilateral_filter pcl_common pcl_io pcl_filters)

  PCL_ADD_EXECUTABLE(pcl_demean_cloud ${SUBSYS_NAME} demean_cloud.cpp)
  target_link_libraries(pcl_demean_cloud pcl_common pcl_io)


  if(BUILD_OPENNI AND OPENNI_FOUND)
    PCL_ADD_EXECUTABLE(pcl_oni2pcd ${SUBSYS_NAME} oni2pcd.cpp)
    target_link_libraries(pcl_oni2pcd pcl_common pcl_io)
  endif(BUILD_OPENNI AND OPENNI_FOUND)

  if (QHULL_FOUND)
    PCL_ADD_EXECUTABLE(pcl_crop_to_hull ${SUBSYS_NAME} crop_to_hull.cpp)
    target_link_libraries(pcl_crop_to_hull pcl_common pcl_io pcl_filters pcl_surface)

    PCL_ADD_EXECUTABLE(pcl_compute_hull ${SUBSYS_NAME} compute_hull.cpp)
    target_link_libraries(pcl_compute_hull pcl_common pcl_io pcl_surface)
  endif (QHULL_FOUND)

  if(NOT VTK_FOUND)
    set(DEFAULT FALSE)
    set(REASON "VTK was not found.")
  else(NOT VTK_FOUND)
      set(DEFAULT TRUE)
      set(REASON)
      set(VTK_USE_FILE ${VTK_USE_FILE} CACHE INTERNAL "VTK_USE_FILE")
      include (${VTK_USE_FILE})
      include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
  
      PCL_ADD_EXECUTABLE(pcl_png2pcd ${SUBSYS_NAME} png2pcd.cpp)
      target_link_libraries(pcl_png2pcd pcl_common pcl_io)

      PCL_ADD_EXECUTABLE (pcl_organized_pcd_to_png ${SUBSYS_NAME} organized_pcd_to_png.cpp)
      target_link_libraries (pcl_organized_pcd_to_png pcl_common pcl_io)

      PCL_ADD_EXECUTABLE(pcl_tiff2pcd ${SUBSYS_NAME} tiff2pcd.cpp)
      target_link_libraries(pcl_tiff2pcd pcl_common pcl_io)
          
      PCL_ADD_EXECUTABLE(pcl_ply2vtk ${SUBSYS_NAME} ply2vtk.cpp)
      target_link_libraries(pcl_ply2vtk pcl_common pcl_io)

      PCL_ADD_EXECUTABLE(pcl_vtk2ply ${SUBSYS_NAME} vtk2ply.cpp)
      target_link_libraries(pcl_vtk2ply pcl_common pcl_io)

      PCL_ADD_EXECUTABLE(pcl_vtk2obj ${SUBSYS_NAME} vtk2obj.cpp)
      target_link_libraries(pcl_vtk2obj pcl_common pcl_io)

      PCL_ADD_EXECUTABLE(pcl_obj2vtk ${SUBSYS_NAME} obj2vtk.cpp)
      target_link_libraries(pcl_obj2vtk pcl_common pcl_io)

      PCL_ADD_EXECUTABLE(pcl_vtk2pcd ${SUBSYS_NAME} vtk2pcd.cpp)
      target_link_libraries(pcl_vtk2pcd pcl_common pcl_io)

      if(BUILD_visualization)
  
        PCL_SUBSYS_DEPEND(build ${SUBSYS_NAME} DEPS visualization)

        PCL_ADD_EXECUTABLE(pcl_obj_rec_ransac_model_opps ${SUBSYS_NAME} obj_rec_ransac_model_opps.cpp)
        target_link_libraries(pcl_obj_rec_ransac_model_opps pcl_common pcl_visualization pcl_recognition)

        PCL_ADD_EXECUTABLE(pcl_obj_rec_ransac_hash_table ${SUBSYS_NAME} obj_rec_ransac_hash_table.cpp)
        target_link_libraries(pcl_obj_rec_ransac_hash_table pcl_common pcl_visualization pcl_io pcl_recognition)

        PCL_ADD_EXECUTABLE(pcl_obj_rec_ransac_scene_opps ${SUBSYS_NAME} obj_rec_ransac_scene_opps.cpp) 
        target_link_libraries(pcl_obj_rec_ransac_scene_opps pcl_common pcl_visualization pcl_io pcl_recognition)

        PCL_ADD_EXECUTABLE(pcl_obj_rec_ransac_accepted_hypotheses ${SUBSYS_NAME} obj_rec_ransac_accepted_hypotheses.cpp) 
        target_link_libraries(pcl_obj_rec_ransac_accepted_hypotheses pcl_common pcl_visualization pcl_io pcl_recognition)

        PCL_ADD_EXECUTABLE(pcl_obj_rec_ransac_orr_octree ${SUBSYS_NAME} obj_rec_ransac_orr_octree.cpp)
        target_link_libraries(pcl_obj_rec_ransac_orr_octree pcl_common pcl_visualization pcl_io pcl_recognition)

        PCL_ADD_EXECUTABLE(pcl_obj_rec_ransac_orr_octree_zprojection ${SUBSYS_NAME} obj_rec_ransac_orr_octree_zprojection.cpp)
        target_link_libraries(pcl_obj_rec_ransac_orr_octree_zprojection pcl_common pcl_visualization pcl_io pcl_recognition)

        PCL_ADD_EXECUTABLE(pcl_obj_rec_ransac_result ${SUBSYS_NAME} obj_rec_ransac_result.cpp)
        target_link_libraries(pcl_obj_rec_ransac_result pcl_common pcl_visualization pcl_io pcl_segmentation pcl_recognition)

        PCL_ADD_EXECUTABLE(pcl_registration_visualizer ${SUBSYS_NAME} registration_visualizer.cpp)
        target_link_libraries(pcl_registration_visualizer pcl_common pcl_io pcl_kdtree pcl_filters pcl_registration pcl_visualization)

        PCL_ADD_EXECUTABLE(pcl_octree_viewer ${SUBSYS_NAME} octree_viewer.cpp)
        target_link_libraries(pcl_octree_viewer pcl_common pcl_io pcl_octree pcl_visualization pcl_kdtree pcl_filters)

        PCL_ADD_EXECUTABLE(pcl_mesh2pcd ${SUBSYS_NAME} mesh2pcd.cpp)
        target_link_libraries(pcl_mesh2pcd pcl_common pcl_io pcl_visualization pcl_filters vtkCommon)
        
        PCL_ADD_EXECUTABLE(pcl_mesh_sampling ${SUBSYS_NAME} mesh_sampling.cpp)
        target_link_libraries(pcl_mesh_sampling pcl_common pcl_io pcl_visualization pcl_filters vtkCommon)
        
        PCL_ADD_EXECUTABLE(pcl_virtual_scanner ${SUBSYS_NAME} virtual_scanner.cpp)
        target_link_libraries(pcl_virtual_scanner pcl_common pcl_io pcl_filters pcl_visualization vtkCommon vtkGraphics)

        PCL_ADD_EXECUTABLE (pcl_voxel_grid_occlusion_estimation ${SUBSYS_NAME} voxel_grid_occlusion_estimation.cpp)
        target_link_libraries (pcl_voxel_grid_occlusion_estimation pcl_common pcl_io pcl_filters pcl_visualization)
        
        if(BUILD_OPENNI AND OPENNI_FOUND)
          PCL_ADD_EXECUTABLE(pcl_openni_save_image ${SUBSYS_NAME} openni_save_image.cpp)
          target_link_libraries(pcl_openni_save_image pcl_common pcl_io pcl_visualization)  
        endif(BUILD_OPENNI AND OPENNI_FOUND)
      endif(BUILD_visualization)
  endif(NOT VTK_FOUND)

  PCL_ADD_EXECUTABLE (pcl_transform_point_cloud ${SUBSYS_NAME} transform_point_cloud.cpp)
  target_link_libraries (pcl_transform_point_cloud pcl_common pcl_io pcl_registration)

  PCL_ADD_EXECUTABLE (pcl_transform_from_viewpoint ${SUBSYS_NAME} transform_from_viewpoint.cpp)

=== visualization/CMakeLists.txt ===
set(SUBSYS_NAME visualization)
set(SUBSYS_DESC "Point cloud visualization library")
set(SUBSYS_DEPS common io kdtree geometry search)

if(NOT VTK_FOUND)
    set(DEFAULT FALSE)
    set(REASON "VTK was not found.")
else(NOT VTK_FOUND)
    set(DEFAULT TRUE)
    set(REASON)
    set(VTK_USE_FILE ${VTK_USE_FILE} CACHE INTERNAL "VTK_USE_FILE")
    include (${VTK_USE_FILE})
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
endif(NOT VTK_FOUND)

PCL_SUBSYS_OPTION(build ${SUBSYS_NAME} ${SUBSYS_DESC} ${DEFAULT} ${REASON})
PCL_SUBSYS_DEPEND(build ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS} EXT_DEPS vtk OPT_DEPS openni)

if (ANDROID)
  set (build FALSE)
  message("VTK was found, but cannot be compiled for Android. Please use VES instead.")
endif ()

find_package(OpenGL)
if (OPENGL_FOUND)
  if(OPENGL_INCLUDE_DIR)
    include_directories("${OPENGL_INCLUDE_DIR}")
  endif()
  if(OPENGL_DEFINITIONS)
    add_definitions("${OPENGL_DEFINITIONS}")
  endif()
endif()

PCL_ADD_DOC(${SUBSYS_NAME})

if(build)
    set(srcs
        src/point_picking_event.cpp
        src/interactor_style.cpp
        src/point_cloud_handlers.cpp
        src/pcl_visualizer.cpp
        src/histogram_visualizer.cpp
        src/common/common.cpp
        src/common/io.cpp
        src/common/shapes.cpp
        src/common/ren_win_interact_map.cpp
        src/cloud_viewer.cpp
        src/image_viewer.cpp
        src/window.cpp
        src/range_image_visualizer.cpp
        src/common/float_image_utils.cpp
        src/vtk/pcl_image_canvas_source_2d.cpp
        src/vtk/pcl_context_item.cpp
        src/vtk/vtkVertexBufferObject.cxx
        src/vtk/vtkVertexBufferObjectMapper.cxx
        src/vtk/vtkRenderWindowInteractorFix.cpp
        )
    if("${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}" VERSION_LESS "5.6")
        # A custom interactor is necessary on VTK 5.4 and below
        set(srcs ${srcs} src/interactor.cpp)
    endif("${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}" VERSION_LESS "5.6")
    
    if("${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}" VERSION_GREATER "5.6")
        # PCLPainter2D uses some functions not present in vtk 5.6
        set(srcs 
            ${srcs} 
            src/pcl_painter2D.cpp
            src/pcl_plotter.cpp
            )
    endif("${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}" VERSION_GREATER "5.6")

    set(incs 
        include/pcl/${SUBSYS_NAME}/eigen.h
        include/pcl/${SUBSYS_NAME}/boost.h
        include/pcl/${SUBSYS_NAME}/cloud_viewer.h
        include/pcl/${SUBSYS_NAME}/histogram_visualizer.h
        include/pcl/${SUBSYS_NAME}/image_viewer.h
        include/pcl/${SUBSYS_NAME}/interactor_style.h
        include/pcl/${SUBSYS_NAME}/pcl_visualizer.h
        include/pcl/${SUBSYS_NAME}/pcl_painter2D.h
        include/pcl/${SUBSYS_NAME}/registration_visualizer.h
        include/pcl/${SUBSYS_NAME}/point_cloud_handlers.h
        include/pcl/${SUBSYS_NAME}/point_cloud_color_handlers.h
        include/pcl/${SUBSYS_NAME}/point_cloud_geometry_handlers.h
        include/pcl/${SUBSYS_NAME}/keyboard_event.h
        include/pcl/${SUBSYS_NAME}/point_picking_event.h
        include/pcl/${SUBSYS_NAME}/area_picking_event.h
        include/pcl/${SUBSYS_NAME}/mouse_event.h
        include/pcl/${SUBSYS_NAME}/window.h
        include/pcl/${SUBSYS_NAME}/range_image_visualizer.h
        include/pcl/${SUBSYS_NAME}/interactor.h
        include/pcl/${SUBSYS_NAME}/vtk.h
        include/pcl/${SUBSYS_NAME}/simple_buffer_visualizer.h
        )
    if("${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}" VERSION_GREATER "5.6")
        set(incs
            ${incs} 
            include/pcl/${SUBSYS_NAME}/pcl_plotter.h
            )
    endif("${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}" VERSION_GREATER "5.6")

    set(common_incs 
        include/pcl/${SUBSYS_NAME}/common/actor_map.h
        include/pcl/${SUBSYS_NAME}/common/common.h
        include/pcl/${SUBSYS_NAME}/common/io.h
        include/pcl/${SUBSYS_NAME}/common/ren_win_interact_map.h
        include/pcl/${SUBSYS_NAME}/common/shapes.h
        include/pcl/${SUBSYS_NAME}/common/float_image_utils.h
        )

    set(impl_incs 
        include/pcl/${SUBSYS_NAME}/impl/histogram_visualizer.hpp
        include/pcl/${SUBSYS_NAME}/impl/pcl_visualizer.hpp
        include/pcl/${SUBSYS_NAME}/impl/image_viewer.hpp
        include/pcl/${SUBSYS_NAME}/impl/registration_visualizer.hpp
        include/pcl/${SUBSYS_NAME}/impl/point_cloud_handlers.hpp
        include/pcl/${SUBSYS_NAME}/impl/point_cloud_color_handlers.hpp
        include/pcl/${SUBSYS_NAME}/impl/point_cloud_geometry_handlers.hpp
        )
    if("${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}" VERSION_GREATER "5.6")
        set(impl_incs
            ${impl_incs} 
            include/pcl/${SUBSYS_NAME}/impl/pcl_plotter.hpp
            )
    endif("${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}" VERSION_GREATER "5.6")


    set(common_impl_incs include/pcl/${SUBSYS_NAME}/common/impl/shapes.hpp
                         include/pcl/${SUBSYS_NAME}/common/impl/common.hpp)

    set(vtk_incs 
        include/pcl/${SUBSYS_NAME}/vtk/pcl_image_canvas_source_2d.h
        include/pcl/${SUBSYS_NAME}/vtk/pcl_context_item.h
        include/pcl/${SUBSYS_NAME}/vtk/vtkVertexBufferObject.h
        include/pcl/${SUBSYS_NAME}/vtk/vtkRenderWindowInteractorFix.h
        include/pcl/${SUBSYS_NAME}/vtk/vtkVertexBufferObjectMapper.h
        )

    # on apple, a workaround is used for the cocoa render window interactor
    if(APPLE)
      list(APPEND srcs
        include/pcl/visualization/vtk/vtkRenderWindowInteractorFix.mm)
    endif()

    set(LIB_NAME pcl_${SUBSYS_NAME})
    PCL_ADD_LIBRARY(${LIB_NAME} ${SUBSYS_NAME} ${srcs} ${incs} ${common_incs} ${impl_incs} ${common_impl_incs} ${vtk_incs})

    # apple workaround (continued)
    if(APPLE)
      target_link_libraries(${LIB_NAME} "-framework Cocoa")
    endif()
     
    if("${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}" VERSION_LESS "5.6")
      target_link_libraries(${LIB_NAME} pcl_common pcl_io pcl_kdtree vtkCommon vtkWidgets vtkHybrid vtkFiltering vtkRendering ${OPENGL_LIBRARIES})
    else()
      target_link_libraries(${LIB_NAME} pcl_common pcl_io pcl_kdtree vtkCommon vtkWidgets vtkHybrid vtkCharts vtkFiltering vtkRendering ${OPENGL_LIBRARIES})
    endif()

    set(EXT_DEPS "")
    if(OPENNI_FOUND)
      list(APPEND EXT_DEPS openni-dev)
    endif(OPENNI_FOUND)
    PCL_MAKE_PKGCONFIG(${LIB_NAME} ${SUBSYS_NAME} "${SUBSYS_DESC}"
      "${SUBSYS_DEPS}" "${EXT_DEPS}" "" "" "")

    # Install include files
    PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME} ${incs})
    PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME}/common ${common_incs})
    PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME}/impl ${impl_incs})
    PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME}/common/impl ${common_impl_incs})
    PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME}/vtk ${vtk_incs})

    if(BUILD_TESTS)
        add_subdirectory(test)
    endif(BUILD_TESTS)

    add_subdirectory(tools)

endif(build)

=== apps/point_cloud_editor/CMakeLists.txt ===
SET(SUBSYS_NAME point_cloud_editor)
SET(SUBSYS_DESC "Point Cloud Editor - Simple editor for 3D point clouds")
SET(SUBSYS_DEPS common filters io apps)

SET(MOC_INCS include/pcl/apps/${SUBSYS_NAME}/cloudEditorWidget.h 
    	 	 include/pcl/apps/${SUBSYS_NAME}/mainWindow.h 
    	 	 include/pcl/apps/${SUBSYS_NAME}/denoiseParameterForm.h 
	 	 	 include/pcl/apps/${SUBSYS_NAME}/statisticsDialog.h 
  )

SET(RSRC resources/pceditor_resources.qrc)

SET(INCS ${MOC_INCS}
  	 	 include/pcl/apps/${SUBSYS_NAME}/cloud.h 
		 include/pcl/apps/${SUBSYS_NAME}/cloudTransformTool.h
		 include/pcl/apps/${SUBSYS_NAME}/command.h
		 include/pcl/apps/${SUBSYS_NAME}/commandQueue.h
		 include/pcl/apps/${SUBSYS_NAME}/common.h
		 include/pcl/apps/${SUBSYS_NAME}/copyBuffer.h
		 include/pcl/apps/${SUBSYS_NAME}/copyCommand.h
		 include/pcl/apps/${SUBSYS_NAME}/cutCommand.h
		 include/pcl/apps/${SUBSYS_NAME}/deleteCommand.h
		 include/pcl/apps/${SUBSYS_NAME}/denoiseCommand.h
		 include/pcl/apps/${SUBSYS_NAME}/localTypes.h
		 include/pcl/apps/${SUBSYS_NAME}/pasteCommand.h
		 include/pcl/apps/${SUBSYS_NAME}/select1DTool.h
		 include/pcl/apps/${SUBSYS_NAME}/select2DTool.h
		 include/pcl/apps/${SUBSYS_NAME}/selection.h
		 include/pcl/apps/${SUBSYS_NAME}/selectionTransformTool.h
		 include/pcl/apps/${SUBSYS_NAME}/statistics.h
		 include/pcl/apps/${SUBSYS_NAME}/toolInterface.h
		 include/pcl/apps/${SUBSYS_NAME}/trackball.h
		 include/pcl/apps/${SUBSYS_NAME}/transformCommand.h
  )

SET(SRCS src/main.cpp 
    	 src/mainWindow.cpp 
    	 src/commandQueue.cpp 
    	 src/selection.cpp 
    	 src/copyBuffer.cpp 
    	 src/deleteCommand.cpp 
    	 src/cutCommand.cpp 
    	 src/pasteCommand.cpp 
    	 src/cloud.cpp 
    	 src/cloudEditorWidget.cpp 
    	 src/cloudTransformTool.cpp 
    	 src/select1DTool.cpp 
    	 src/select2DTool.cpp 
    	 src/selectionTransformTool.cpp 
    	 src/transformCommand.cpp 
    	 src/common.cpp 
    	 src/denoiseCommand.cpp 
    	 src/statistics.cpp 
    	 src/statisticsDialog.cpp 
    	 src/trackball.cpp 
    	 src/denoiseParameterForm.cpp
  )

IF(NOT QT4_FOUND)
  SET(DEFAULT FALSE)
  SET(REASON "Qt4 was not found.")
ELSE(NOT QT4_FOUND)
  SET(DEFAULT TRUE)
  SET(REASON)
ENDIF(NOT QT4_FOUND)
# Find OpenGL
find_package(OpenGL)
IF(NOT OPENGL_FOUND)
  SET(DEFAULT FALSE)
  SET(REASON "OpenGL was not found.")
ELSE(NOT OPENGL_FOUND)
  SET(DEFAULT TRUE)
  SET(REASON)
ENDIF(NOT OPENGL_FOUND)


# Default to not building for now
set(DEFAULT FALSE)
SET(REASON "")

PCL_SUBSYS_OPTION(BUILD app_${SUBSYS_NAME} ${SUBSYS_DESC} ${DEFAULT} ${REASON})
PCL_SUBSYS_DEPEND(BUILD app_${SUBSYS_NAME} ${SUBSYS_DEPS})
PCL_ADD_DOC(${SUBSYS_NAME})

IF(BUILD)

  INCLUDE(${QT_USE_FILE})
  SET(QT_USE_QTOPENGL TRUE)
  #QT4_WRAP_CPP(MOC_SRCS ${MOC_INCS})
  QT4_WRAP_CPP(MOC_SRCS ${MOC_INCS} OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED)
  QT4_ADD_RESOURCES(RESOURCES_SRCS ${RSRC})

  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}
                      ${CMAKE_CURRENT_SOURCE_DIR}/include
                      ${QT_QT_INCLUDE_DIR}
                      ${QT_QTOPENGL_INCLUDE_DIR}
    )

  SET(EXE_NAME pcl_${SUBSYS_NAME})
  PCL_ADD_EXECUTABLE(${EXE_NAME} 
				  	 ${SUBSYS_NAME} 
					 ${SRCS} 
					 ${RESOURCES_SRCS}
					 ${MOC_SRCS}
					 ${INCS}
    )

  TARGET_LINK_LIBRARIES(${EXE_NAME} 
				  		${QT_LIBRARIES}
						${QT_QTOPENGL_LIBRARY}
						${OPENGL_LIBRARIES}
						${BOOST_LIBRARIES}
						pcl_common
						pcl_io
						pcl_filters
    )

  SET(CMAKE_CXX_FLAGS "-Wno-invalid-offsetof -Wno-extra-tokens")

  PCL_ADD_INCLUDES(${SUBSYS_NAME} ${SUBSYS_NAME} ${INCS})
  PCL_MAKE_PKGCONFIG(${EXE_NAME} ${SUBSYS_NAME} "${SUBSYS_DESC}" "" "" "" "" "")

ENDIF(BUILD)

=== test/io/CMakeLists.txt ===
if(OPENNI_FOUND)
    PCL_ADD_TEST(io_io test_io
                  FILES test_io.cpp
                  LINK_WITH pcl_gtest pcl_io)
endif(OPENNI_FOUND)
PCL_ADD_TEST(io_iterators test_iterators
              FILES test_iterators.cpp
              LINK_WITH pcl_gtest pcl_io)

PCL_ADD_TEST(compression_range_coder test_range_coder
          FILES test_range_coder.cpp
          LINK_WITH pcl_gtest pcl_io)

PCL_ADD_TEST (io_grabbers test_grabbers
              FILES test_grabbers.cpp
              LINK_WITH pcl_gtest pcl_io
              ARGUMENTS ${PCL_SOURCE_DIR}/test/grabber_sequences)
# Uses VTK readers to verify            
if (VTK_FOUND AND NOT ANDROID)
  PCL_ADD_TEST (io_ply_mesh_io test_ply_mesh_io
                FILES test_ply_mesh_io.cpp
                LINK_WITH pcl_gtest pcl_io
                ARGUMENTS ${PCL_SOURCE_DIR}/test/tum_rabbit.vtk)
endif ()

=== debian/changelog ===
pcl-1.7 (1.7.0-2+precise2) precise; urgency=low

  * Change OpenNI dependencies to openni-dev and ps-engine to be compatible
    with old versions.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Wed, 14 Aug 2013 17:21:51 +0200

pcl-1.7 (1.7.0-2+precise1) precise; urgency=low

  * Fix typo (features instead of feature).

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Wed, 14 Aug 2013 09:51:18 +0200

pcl-1.7 (1.7.0-1+precise2) precise; urgency=low

  * Add 0001-Use-__SSE__-instead-of-HAVE_SSE_EXTENSIONS.patch to fix compiler
    error.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Tue, 13 Aug 2013 17:01:49 +0200

pcl-1.7 (1.7.0-1+precise1) precise; urgency=low

  * New upstream release.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Tue, 13 Aug 2013 09:11:53 +0200

pcl-1.6 (1:1.6.0-1+raring2) raring; urgency=low

  * Change dependencies from ps-engine to libopenni-sensor-primesense0.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Mon, 20 May 2013 09:58:45 +0200

pcl-1.6 (1:1.6.0-1+raring1) raring; urgency=low

  * Upload to raring.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Sun, 19 May 2013 10:45:56 +0200

pcl-1.6 (1:1.6.0-1+quantal1) quantal; urgency=low

  * New upstream release.
  * Add epoch because I've used the wrong version number for the release
    candidate.
  * Change build dependency from libflann1.7-dev to libflann-dev.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Wed, 18 Jul 2012 04:02:23 +0200

pcl-1.6 (1.6.0rc1-1+quantal1) quantal; urgency=low

  * New upstream release.
  * Add new libpcl-geometry lib.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Sat, 07 Jul 2012 10:28:27 +0200

pcl-1.5 (1.5.1-1+quantal3) quantal; urgency=low

  * Fix c&p error in doxygen generation.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Tue, 28 Feb 2012 09:22:22 +0100

pcl-1.5 (1.5.1-1+quantal2) quantal; urgency=low

  * Fix doxygen generation (wrong make path).

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Mon, 27 Feb 2012 17:38:19 +0100

pcl-1.5 (1.5.1-1+quantal1) quantal; urgency=low

  * New upstream release.
  * Add libpcl_io_ply.so to libpcl-io.
  * Fix location of documentation.
  * Integrated pcl_rage_image into pcl_common.
  * Set -DCMAKE_BUILD_TYPE=Debug to only build with system build flags.
  * Add new libpcl-tracking lib.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Thu, 23 Feb 2012 01:50:08 +0100

pcl-1.4 (1.4.0-1+quantal1) quantal; urgency=low

  * New upstream release.
  * Bump Flann dependency to libflann1.7-dev.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Tue, 03 Jan 2012 17:51:51 +0100

pcl-1.3 (1.3.1a-1+quantal1) quantal; urgency=low

  * New upstream release.
  * Please note that this is the "new" 1.3.1 release as of 03 Dec 2011 because
    upstream decided to release it again, hence the epoch.
  * Removed superfluous dependency on libboost-dev.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Sat, 03 Dec 2011 17:36:09 +0100

pcl-1.3 (1.3.1-1+quantal1) quantal; urgency=low

  * New upstream release.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Thu, 03 Nov 2011 19:26:52 +0100

pcl-1.3 (1.3.0-1+quantal3) quantal; urgency=low

  * Add conflicts against PCL 1.2.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Thu, 03 Nov 2011 09:34:19 +0100

pcl-1.3 (1.3.0-1+quantal2) quantal; urgency=low

  * Add Boost iostreams as dependency.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Wed, 02 Nov 2011 21:56:10 +0100

pcl-1.3 (1.3.0-1+quantal1) quantal; urgency=low

  * New upstream release.
  * remove fix_pkgconfig patch (merged upstream).

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Wed, 02 Nov 2011 17:42:09 +0100

pcl-1.2 (1.2.0-1+quantal8) quantal; urgency=low

  * Accidentally removed Boost dependencies (again)

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Sat, 29 Oct 2011 20:04:13 +0200

pcl-1.2 (1.2.0-1+quantal7) quantal; urgency=low

  * Fix typo in pkg-config file (thanks Bastian).

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Sat, 29 Oct 2011 16:52:50 +0200

pcl-1.2 (1.2.0-1+quantal6) quantal; urgency=low

  * Fixed typo in control file.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Tue, 04 Oct 2011 07:38:31 +0200

pcl-1.2 (1.2.0-1+quantal5) quantal; urgency=low

  * Accidentally removed Boost dependencies.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Tue, 04 Oct 2011 07:08:43 +0200

pcl-1.2 (1.2.0-1+quantal4) quantal; urgency=low

  * Hack around old debhelper in Debian to make documentation compile (see
    rules).

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Mon, 03 Oct 2011 23:08:13 +0200

pcl-1.2 (1.2.0-1+quantal3) quantal; urgency=low

  * Added python-sphinx as build dependency (needed for
    -DBUILD_documentation=ON but not used).
  * Unversion Boost dependency (given that we use a different version of
    OpenNI than ROS we are incompatible with it anyhow, so there is no point
    in sticking with the same Boost version as in ROS).
  * Only depend on system filesystem thread and date_time of Boost.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Mon, 03 Oct 2011 09:37:13 +0200

pcl-1.2 (1.2.0-1+quantal2) quantal; urgency=low

  * Fix libpcl-filtering-1.2-dev -> libpcl-filters-1.2-dev.
  * Fix libpcl-feature-1.2-dev -> libpcl-features-1.2-dev.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Mon, 03 Oct 2011 00:01:25 +0200

pcl-1.2 (1.2.0-1+quantal1) quantal; urgency=low

  * New upstream release.
  * Added doc package with doxygen documentation.
  * Split into separate packages.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Sat, 01 Oct 2011 17:41:49 +0200

pcl-1.1 (1.1.1-1+quantal1) quantal; urgency=low

  * New upstream release.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Wed, 31 Aug 2011 23:15:17 +0200



=== debian/control ===
Source: pcl-1.7
Priority: optional
Maintainer: Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>
Build-Depends: debhelper (>= 9), cmake, libboost-system-dev, libboost-filesystem-dev, libboost-thread-dev, libboost-date-time-dev, libboost-iostreams-dev, libeigen3-dev, libflann-dev, libusb-1.0-0-dev, openni-dev, libpng12-dev, libqhull-dev, libvtk5-qt4-dev, doxygen-latex, python-sphinx
Standards-Version: 3.9.1
Section: libs
Homepage: http://pointclouds.org/

Package: libpcl-1.7-all
Section: devel
Architecture: all
Depends: ${misc:Depends}, libpcl-1.7-all-dev, libpcl-1.7-bin, libpcl-1.7-doc
Description: The Point Cloud Library (or PCL) for point cloud processing - development
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package depends on all PCL packages.

Package: libpcl-1.7-all-dev
Section: libdevel
Architecture: all
Depends: ${misc:Depends}, libpcl-apps-1.7-dev, libpcl-common-1.7-dev, libpcl-features-1.7-dev, libpcl-filters-1.7-dev, libpcl-geometry-1.7-dev, libpcl-io-1.7-dev, libpcl-kdtree-1.7-dev, libpcl-keypoints-1.7-dev, libpcl-octree-1.7-dev, libpcl-outofcore-1.7-dev, libpcl-people-1.7-dev, libpcl-recognition-1.7-dev, libpcl-registration-1.7-dev, libpcl-sample-consensus-1.7-dev, libpcl-search-1.7-dev, libpcl-segmentation-1.7-dev, libpcl-surface-1.7-dev, libpcl-tracking-1.7-dev, libpcl-visualization-1.7-dev
Description: The Point Cloud Library (or PCL) for point cloud processing - development
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package depends on all PCL development packages.

Package: libpcl-apps-1.7-dev
Section: libdevel
Architecture: any
Conflicts: libpcl-apps-1.3-dev, libpcl-apps-1.4-dev, libpcl-apps-1.5-dev, libpcl-apps-1.6-dev
Depends: libpcl-apps-1.7 (= ${binary:Version}), ${misc:Depends}, libpcl-common-1.7-dev, libpcl-geometry-1.7-dev, libpcl-io-1.7-dev, libpcl-filters-1.7-dev, libpcl-sample-consensus-1.7-dev, libpcl-segmentation-1.7-dev, libpcl-visualization-1.7-dev, libpcl-kdtree-1.7-dev, libpcl-features-1.7-dev, libpcl-surface-1.7-dev, libpcl-octree-1.7-dev, libpcl-registration-1.7-dev, libpcl-keypoints-1.7-dev, libpcl-tracking-1.7-dev, libpcl-search-1.7-dev, libpcl-recognition-1.7-dev, openni-dev, libvtk5-qt4-dev
Description: The Point Cloud Library (or PCL) for point cloud processing - development
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains development files needed to build applications depending on PCL apps.

Package: libpcl-apps-1.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The Point Cloud Library (or PCL) for point cloud processing - runtime
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications depending on PCL apps.

Package: libpcl-common-1.7-dev
Section: libdevel
Architecture: any
Depends: libpcl-common-1.7 (= ${binary:Version}), ${misc:Depends}, libeigen3-dev, libboost-system-dev, libboost-filesystem-dev, libboost-thread-dev, libboost-date-time-dev, libboost-iostreams-dev
Suggests: cmake, libpcl-1.7-doc
Conflicts: libpcl-1.0-dev, libpcl-1.1-dev, libpcl-common-1.2-dev, libpcl-common-1.3-dev, libpcl-common-1.4-dev, libpcl-common-1.5-dev, libpcl-common-1.6-dev
Description: The Point Cloud Library (or PCL) for point cloud processing - development
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains development files needed to build applications depending on PCL common.

Package: libpcl-common-1.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The Point Cloud Library (or PCL) for point cloud processing - runtime
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications depending on PCL common.

Package: libpcl-1.7-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: The Point Cloud Library (or PCL) for point cloud processing - runtime
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the doxygen documentation of PCL.

Package: libpcl-features-1.7-dev
Section: libdevel
Architecture: any
Conflicts: libpcl-features-1.2-dev, libpcl-features-1.3-dev, libpcl-features-1.4-dev, libpcl-features-1.5-dev, libpcl-features-1.6-dev
Depends: libpcl-features-1.7 (= ${binary:Version}), ${misc:Depends}, libpcl-common-1.7-dev, libpcl-search-1.7-dev, libpcl-kdtree-1.7-dev, libpcl-octree-1.7-dev, libpcl-filters-1.7-dev
Description: The Point Cloud Library (or PCL) for point cloud processing - development
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains development files needed to build applications depending on PCL features.

Package: libpcl-features-1.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The Point Cloud Library (or PCL) for point cloud processing - runtime
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications depending on PCL features.

Package: libpcl-filters-1.7-dev
Section: libdevel
Architecture: any
Conflicts: libpcl-filters-1.2-dev, libpcl-filters-1.3-dev, libpcl-filters-1.4-dev, libpcl-filters-1.5-dev, libpcl-filters-1.6-dev
Depends: libpcl-filters-1.7 (= ${binary:Version}), ${misc:Depends}, libpcl-common-1.7-dev, libpcl-sample-consensus-1.7-dev, libpcl-search-1.7-dev, libpcl-kdtree-1.7-dev, libpcl-octree-1.7-dev
Description: The Point Cloud Library (or PCL) for point cloud processing - development
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains development files needed to build applications depending on PCL filters.

Package: libpcl-filters-1.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The Point Cloud Library (or PCL) for point cloud processing - runtime
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications depending on PCL filters.

Package: libpcl-geometry-1.7-dev
Section: libdevel
Architecture: any
Conflicts: libpcl-geometry-1.6-dev
Depends: ${misc:Depends}, libpcl-common-1.7-dev
Description: The Point Cloud Library (or PCL) for point cloud processing - development
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains development files needed to build applications depending on PCL geometry.

Package: libpcl-io-1.7-dev
Section: libdevel
Architecture: any
Conflicts: libpcl-io-1.2-dev, libpcl-io-1.3-dev, libpcl-io-1.4-dev, libpcl-io-1.5-dev, libpcl-io-1.6-dev
Depends: libpcl-io-1.7 (= ${binary:Version}), ${misc:Depends}, libpcl-common-1.7-dev, libpcl-octree-1.7-dev, openni-dev, libvtk5-dev, libusb-1.0-0-dev
Description: The Point Cloud Library (or PCL) for point cloud processing - development
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains development files needed to build applications depending on PCL io.

Package: libpcl-io-1.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ps-engine
Description: The Point Cloud Library (or PCL) for point cloud processing - runtime
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications depending on PCL io.

Package: libpcl-kdtree-1.7-dev
Section: libdevel
Architecture: any
Conflicts: libpcl-kdtree-1.2-dev, libpcl-kdtree-1.3-dev, libpcl-kdtree-1.4-dev, libpcl-kdtree-1.5-dev, libpcl-kdtree-1.6-dev
Depends: libpcl-kdtree-1.7 (= ${binary:Version}), ${misc:Depends}, libpcl-common-1.7-dev, libflann-dev
Description: The Point Cloud Library (or PCL) for point cloud processing - development
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains development files needed to build applications depending on PCL kdtree.

Package: libpcl-kdtree-1.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The Point Cloud Library (or PCL) for point cloud processing - runtime
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications depending on PCL kdtree.

Package: libpcl-keypoints-1.7-dev
Section: libdevel
Architecture: any
Conflicts: libpcl-keypoints-1.2-dev, libpcl-keypoints-1.3-dev, libpcl-keypoints-1.4-dev, libpcl-keypoints-1.5-dev, libpcl-keypoints-1.6-dev
Depends: libpcl-keypoints-1.7 (= ${binary:Version}), ${misc:Depends}, libpcl-common-1.7-dev, libpcl-search-1.7-dev, libpcl-kdtree-1.7-dev, libpcl-octree-1.7-dev, libpcl-features-1.7-dev, libpcl-filters-1.7-dev
Description: The Point Cloud Library (or PCL) for point cloud processing - development
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains development files needed to build applications depending on PCL keypoints.

Package: libpcl-keypoints-1.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The Point Cloud Library (or PCL) for point cloud processing - runtime
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications depending on PCL keypoints.

Package: libpcl-octree-1.7-dev
Section: libdevel
Architecture: any
Conflicts: libpcl-octree-1.2-dev, libpcl-octree-1.3-dev, libpcl-octree-1.4-dev, libpcl-octree-1.5-dev, libpcl-octree-1.6-dev
Depends: libpcl-octree-1.7 (= ${binary:Version}), ${misc:Depends}, libpcl-common-1.7-dev
Description: The Point Cloud Library (or PCL) for point cloud processing - development
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .

=== debian/rules ===
#!/usr/bin/make -f

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

%:
	dh $@ --parallel --builddirectory=build

override_dh_auto_build-indep:
	$(MAKE) -C build doc

override_dh_auto_configure:
	dh_auto_configure -- 						\
	-DCMAKE_SKIP_RPATH=ON						\
	-DBUILD_apps=ON
